#!/usr/bin/python
# -*- encoding: utf-8 -*-

# Classe do teclado SMAK
# Possui 2 linhas de 40 caracteres
import os
from sigpdv.tools.log import traced as log
# from stoqdrivers.logs.log import traced as log
import threading
import socket
import time


class Smak(object):
    @log
    def start_smak_server(self):
        # Servidor Smak
        try:
            senha = 'sig'
            log.info("Servico Smak iniciado...")
            porta = 5000 # porta em que o servico tcp ira iniciar
            os.system("echo '%s' | sudo -S /usr/bin/./smak %s" % (senha, porta))

        except Exception as e:
            log.error("Erro na funcao 'start_smak_server': %s"  % str(e))
            print "Erro na funcao 'start_smak_server': %s"  % str(e)

        return True

    @log
    def start_smak_client(self):
        cont = 0
        while cont < 100: # tenta conectar no servidor smak X vezes
            cont += 1
            try:
                time.sleep(1) # tempo de espera para iniciar o servidor smak
                # Create a TCP/IP socket
                sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                # Connect the socket to the port where the server is listening
                server_address = ('localhost', 5000)
                log.info('connecting to %s port %s' % server_address)
                print 'connecting to %s port %s' % server_address
                sock.connect(server_address)
                fim = False
                while not fim:
                    # Send data
                    while not self.comando:
                        time.sleep(0.1)

                    len_comando = len(self.comando)
                    for i in range(len_comando):
                        if self.comando[0].startswith('999'):
                            fim = True
                            break

                        log.info('CMD Teclado: %s' % self.comando[0])
                        print 'CMD Teclado: %s' % self.comando[0]
                        sock.sendall(self.comando[0])
                        self.comando.remove(self.comando[0])
                        data = sock.recv(30)
                        if 'Fim' in data:
                            fim = True
                            break

            except Exception as e:
                log.error('Erro no display do teclado: %s' % str(e))
                print 'Erro no display do teclado: %s' % str(e)
                continue

            self.parent.teclado = False
            try:
                sock.close()
                print 'closing socket'
                os.system('echo %s | sudo -S %s' % ('sig', 'killall -9 smak'))
                cont = 999
            except Exception as e:
                cont = 999
                log.error('Erro na thread do display do teclado: %s' % str(e))
                print 'Erro na thread do display do teclado: %s' % str(e)

    def __init__(self, parent):
        self.parent = parent
        self.smak_server = threading.Thread(name='smak_server', target=self.start_smak_server)
        self.smak_client = threading.Thread(name='smak_client', target=self.start_smak_client)
        self.comando = []

    def iniciar_teclado(self):
        self.smak_server.start()
        self.smak_client.start()

    def fechar_teclado(self):
        self.envia_comando('99934000xx')

    def envia_comando(self, cmd):
        '''
        cmd =  'aaabbccdee'
             aaa - Codigo para para o servidor C (999=para)
              bb - codigo para o tipo de operacao
              cc - numero da coluna do cursor
               y - linha do cursor
              xx - Texto a ser enviado, o tamanho eh o proprio texto
              
        envia = False coloca uma lista de comandos a serem executados
        '''
        self.comando.append(cmd)

    def limpar_display(self):
        self.envia_comando('00003000xx')
        return True

    def go_to(self, x, y):
        # posiciona o cursor na coluna x, linha y. A letra 'a' passada nao serve para nada, apenas
        # para organizar a quantidade de parametros
        self.envia_comando('00012%02d%sxx' % (x,y))
        return True

    def limpar_linha(self, nro_linha):
        if nro_linha == 1: # apaga a primeira linha
            self.envia_comando('00004000xx')
            self.go_to(1,1)
        else: # apaga a segunda linha
            self.envia_comando('00005000xx')
            self.go_to(1,2)

        return True

    def envia_display(self, texto, limpa_display=True):
        texto = self.parent.remove_accents(texto.replace('&', ''))
        texto = self.formata_texto(texto)
        if limpa_display:
            self.limpar_display()

        self.envia_comando('00014000%s' % str(texto))

    def envia_linha_display(self, texto, linha):
        self.limpar_linha(linha)
        self.envia_display(self.formata_texto(texto), limpa_display=False)

    def envia_botoes_display(self, texto):
        self.limpar_linha(2)
        self.envia_display(texto, limpa_display=False)

    def formata_texto(self, texto):
        '''
        Formata as quebras de linha do texto
        '''
        aux = []
        cont = 0
        texto = texto.replace('\n', ' ')
        tam_texto = len(texto)
        for i in range(0, tam_texto / 39 +1):
            aux.append('%s' % texto[cont: cont+39])
            cont += 39
            if cont > tam_texto:
                return ''.join(aux)