#!/usr/bin/python
# -*- coding: utf-8 -*-


from gertec.gertec_44_usb import Gertec_44_usb
from gertec.gertec_44_ps2 import Gertec_44_ps2
from gertec.gertec_55_ps2 import Gertec_55_ps2
from gertec.gertec_55_usb import Gertec_55_usb
from gertec.gertec_65_ps2 import Gertec_65_ps2
from gertec.gertec_65_usb import Gertec_65_usb
from gertec.gertec_65_unisys import Gertec_65_unisys
from smak.smak import Smak


TIPOS_TECLADO = {1: Gertec_44_ps2, 2: Gertec_44_usb, 3: Gertec_55_ps2, 4: Gertec_55_usb,
                 5: Gertec_65_ps2, 6: Gertec_65_usb, 7: Gertec_65_unisys, 8: Smak,
                 9: Smak, 10: Smak, 11: Smak, 12: Smak, 13: Smak, 14: Smak}

class Teclado(object):
    """
    Classe responsavel por gerenciar, para qual tipo de teclado serao enviado os comandos
    """
    def __init__(self, parent, tipo_teclado):
        self.parent = parent
        self.obj_teclado = TIPOS_TECLADO.get(tipo_teclado)(self.parent)
        if tipo_teclado in [1,2,3,4,5,6,7]: # gertec
            self.parent.linhas_display = 4
        elif tipo_teclado in [9,10,11,12,13,14]: # smak
            self.parent.linhas_display = 2

        self.obj_teclado.iniciar_teclado()

    def fechar_teclado(self):
        self.obj_teclado.fechar_teclado()

    def limpar_display(self):
        self.obj_teclado.limpar_display()

    def limpar_linha(self, nro_linha):
        self.obj_teclado.limpar_linha(nro_linha)

    def envia_display(self, texto, limpa_display=True):
        self.obj_teclado.envia_display(texto, limpa_display=limpa_display)

    def envia_linha_display(self, texto, linha):
        self.obj_teclado.envia_linha_display(texto, linha)

    def envia_botoes_display(self, texto):
        self.obj_teclado.envia_botoes_display(texto)

    def go_to(self, x, y):
        self.obj_teclado.go_to(x, y)
