#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.cad_promo1_data import CaixaCadPromo1 # deve ficar para executar 'eval()
from sigpdv.models.db_utils import exec_sql
from datetime import datetime
from decimal import Decimal

TWOPLACES = Decimal(10) ** -2


class CadPromo1(object):
    def __init__(self, parent):
        self.parent = parent

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    filters += ".filter(CaixaCadPromo1.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaCadPromo1.%s == %s)" % (key, value)

            query = 'CaixaCadPromo1.query%s' % filters
            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()

        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def calcula_promocao1(self):
        capa_id = self.parent.mov_capa.id
        indice = 0
        nItens = 0
        nDesconto = 0.0
        x = 0
        nQtde = 0
        nFez = 0
        ValDsc = 0.0
        Agora = ''
        DataPesq = ''
        sFilter = ''
        varQtde = 0.0
        nSeq = 0
        PctsPai = 0
        Pacotes = 0
        nCond = 0
        DescontoPack = 0.0
        lNaoPode = False
        MaxPcts = 0
        lTestar = False
        ItensPct = 0.0
        errPromo = False
        MaxPromo = 0.0
        
        DataPesq = str(datetime.now())[:19]
        sql = ''' SELECT cpc.supproc_id_promo              AS id_promocao,
                         cpc.supproc_tipo_promo,
                         cpc.supproc_maximo                AS maximo,
                         cpc.supproc_scanntech             AS tipo_promo,
                         cpc.supproc_finalizadora_dinheiro AS somente_dineheiro,
                         cp1.suppro1_barras                AS barras,
                         cp1.suppro1_quantidade            AS quantidade,
                         cp1.suppro1_desconto              AS desconto,
                         cp1.suppro1_tipo_desconto,
                         cp1.suppro1_sequencial    AS sequencial
                 FROM caixa_cad_promo_capa   AS cpc
                 INNER JOIN caixa_cad_promo1 AS cp1 ON cp1.suppro1_capa_id = cpc.id
                 WHERE cpc.supproc_data_hora_inicio <= '{data}' at time zone 'UTC'
                   AND cpc.supproc_data_hora_fim >= '{data}' at time zone 'UTC'
                 ORDER BY cpc.supproc_id_promo, cp1.suppro1_sequencial
                 '''.format(data=DataPesq)
        RsPromo1 = exec_sql(sql, 'C')
        if RsPromo1:
            while indice < len(RsPromo1):
                nCond = 0
                MaxPcts = 10000
                nID = RsPromo1[indice].get('id_promocao')
                nSeq = RsPromo1[indice].get('sequencial')
                DescontoPack = RsPromo1[indice].get('desconto')
                MaxPromo = RsPromo1[indice].get('maximo')
                lNaoPode = False
                QtdProd = []
                Vr_itens_pack = Decimal(0) # valor total do pack
                Filtros = []
                sFilter = """supcor_capa_id = {capa_id}
                         AND supcor_venda_cancelamento='V'  
                         AND supcor_desconto_item < 0.01 
                         AND supcor_acrescimo_item < 0.01 
                         AND (supcor_item='""".format(capa_id=capa_id) + RsPromo1[indice].get('barras') + "'"
                indice += 1
                while indice < len(RsPromo1):
                    if RsPromo1[indice].get('id_promocao') <> nID:
                        break
                    if RsPromo1[indice].get('sequencial') == nSeq:
                        sFilter = sFilter + " OR supcor_item='" + RsPromo1[indice].get('barras') + "'"
                    else:
                        nSeq = RsPromo1[indice].get('sequencial')
                        indice -= 1
                        sFilter = sFilter + ")"
                        sql = """SELECT SUM(supcor_quantidade) AS nqtde,
                                        supcor_preco_unitario  AS preco_unitatio
                                 FROM caixa_mov_corpos WHERE """ + sFilter + """GROUP BY  supcor_preco_unitario"""
                        TmpItens = exec_sql(sql, 'C')
                        if TmpItens:
                            nItens = sum(map(lambda x: x.get('nqtde'), TmpItens)) # Quantos itens encontrou do pai
                            if nItens >= RsPromo1[indice].get('quantidade'):
                                QtdProd.append(RsPromo1[indice].get('quantidade'))         # 'Quantos produtos dessa condicao s�o usados no pack
                                Vr_itens_pack += sum(map(lambda x: RsPromo1[indice].get('quantidade')
                                                               * x.get('preco_unitatio'), TmpItens))
                                Filtros.append(sFilter)                                    # 'Filtro dessa condi��o
                                Pacotes = int(nItens / RsPromo1[indice].get('quantidade')) # 'Quantos pacotes consigo formas pra essa condi��o
                                nCond = nCond + 1                                          # 'Soma numero de condi��es
                                if Pacotes < MaxPcts:
                                    MaxPcts = Pacotes                # 'Vamos guardar a menor qtd de packs dentre as condi��es
                            else:
                                lNaoPode = True
                                indice += 1
                                break
                                
                        else:
                            lNaoPode = True
                            indice += 1
                            break
                            
                        indice += 1
                        sFilter = """supcor_capa_id = {capa_id}
                                 AND supcor_venda_cancelamento='V'  
                                 AND supcor_desconto_item < 0.01 
                                 AND supcor_acrescimo_item < 0.01 
                                 AND (supcor_item='""".format(capa_id=capa_id) + RsPromo1[indice].get('barras') + "'"

                    indice += 1
                
                if lNaoPode == False: # Da pra fazer pack
                    indice -= 1
                    sFilter = sFilter + ")"
                    sql = """SELECT SUM(supcor_quantidade) AS nqtde,
                                    supcor_preco_unitario  AS preco_unitatio
                            FROM caixa_mov_corpos WHERE """ + sFilter + """GROUP BY  supcor_preco_unitario"""
                    TmpItens = exec_sql(sql, 'C')
                    if TmpItens:
                        nItens = sum(map(lambda x: x.get('nqtde'), TmpItens)) # 'Quantos itens encontrou do pai
                        if nItens >= RsPromo1[indice].get('quantidade'):
                            QtdProd.append(RsPromo1[indice].get('quantidade'))           # 'Quantos produtos dessa condicao s�o usados no pack
                            Vr_itens_pack += sum(map(lambda x: RsPromo1[indice].get('quantidade')
                                                           * x.get('preco_unitatio'), TmpItens))
                            Filtros.append(sFilter)                                      # 'Filtro dessa condi��o
                            Pacotes = int(nItens / RsPromo1[indice].get('quantidade'))   #  'Quantos pacotes consigo formas pra essa condi��o
                            nCond = nCond + 1                                            #  'Soma numero de condi��es
                            if Pacotes < MaxPcts:
                                MaxPcts = Pacotes                  #  'Vamos guardar a menor qtd de packs dentre as condi��es
                        else:
                            lNaoPode = True
                        
                    else:
                        lNaoPode = True
                    
                    if lNaoPode == False:
                        MaxPcts = MaxPromo if MaxPcts > MaxPromo else MaxPcts
                        ItensPct = 0
                        for x in range(len(QtdProd)):
                            ItensPct = ItensPct + QtdProd[x]

                        # ValDsc = DescontoPack / ItensPct # (DescontoPack / (ItensPct * Pacotes))
                        desconto_dado = Decimal(0).quantize(TWOPLACES)
                        maior_item = {'seq':0, 'valor': Decimal(0)}
                        for x in range(len(Filtros)):
                            sql = "SELECT * FROM caixa_mov_corpos WHERE " + Filtros[x] + " Order By supcor_sequencia"
                            TmpItens = exec_sql(sql, 'C')
                            indice_corpos = 0
                            nFez = 0
                            nQtde = (QtdProd[x] * MaxPcts)
                            while indice_corpos < len(TmpItens):
                                ValDsc = Decimal(TmpItens[indice_corpos].get('supcor_preco_unitario')
                                                 * DescontoPack / Vr_itens_pack).quantize(TWOPLACES)
                                if TmpItens[indice_corpos].get('supcor_quantidade') > QtdProd[x]:
                                    if TmpItens[indice_corpos].get('supcor_quantidade') > (nQtde - nFez):
                                        nDesconto = ValDsc * (nQtde - nFez)
                                        varQtde = (nQtde - nFez)
                                        nFez = nFez + (nQtde - nFez)
                                    else:
                                        varQtde = TmpItens[indice_corpos].get('supcor_quantidade')
                                        nDesconto = ValDsc * TmpItens[indice_corpos].get('supcor_quantidade')
                                        nFez = nFez + TmpItens[indice_corpos].get('supcor_quantidade')
                                    
                                else:
                                    if TmpItens[indice_corpos].get('supcor_quantidade') > (nQtde - nFez):
                                        nDesconto = ValDsc * (nQtde - nFez)
                                        varQtde = (nQtde - nFez)
                                        nFez = nFez + (nQtde - nFez)
                                    else:
                                        nDesconto = ValDsc * TmpItens[indice_corpos].get('supcor_quantidade')
                                        varQtde = TmpItens[indice_corpos].get('supcor_quantidade')
                                        nFez = nFez + TmpItens[indice_corpos].get('supcor_quantidade')
                                    
                                nDesconto = Decimal(nDesconto).quantize(TWOPLACES)
                                if nDesconto > 0 and nDesconto < TmpItens[indice_corpos].get('supcor_preco_total'):
                                    vr_total_item = TmpItens[indice_corpos].get('supcor_preco_unitario') * \
                                                    varQtde
                                    if vr_total_item > maior_item.get('valor'):
                                        maior_item.update({'seq': TmpItens[indice_corpos].get('supcor_sequencia'),
                                                           'valor': vr_total_item})

                                    desconto_dado += nDesconto
                                    self.parent.list_itens_desconto_promo.append(
                                    {'sequencia_item':TmpItens[indice_corpos].get('supcor_sequencia'),
                                     'desconto': nDesconto.quantize(TWOPLACES),
                                     'id_promo': str(nID).zfill(6),
                                     'quantidade': varQtde,
                                     'tipo_promo': '1' if RsPromo1[indice].get('tipo_promo') else '2',
                                     'somente_dinheiro': RsPromo1[indice].get('somente_dineheiro'),
                                    })
                                    if str(nQtde).zfill(5) == str(nFez).zfill(5):
                                        break

                                    indice_corpos += 1
                                else:
                                    Log.info("Desconto Inválido. Promoção-1: " + str(nID).zfill(6))
                                    promo_delete = filter(lambda y: y.get('id_promo') == str(nID).zfill(6)
                                                              and y.get('id_promo') == '1', self.parent.list_itens_desconto_promo)
                                    map(lambda x: self.parent.list_itens_desconto_promo.remove(x), promo_delete)
                                    errPromo = True
                                    break

                            if errPromo:
                                break

                        dif = DescontoPack*MaxPcts - desconto_dado
                        if not (Decimal(-0.01).quantize(TWOPLACES) < dif
                                and dif < Decimal(0.01).quantize(TWOPLACES)):
                            map(lambda y: y.update({'desconto': y.get('desconto') + dif})
                                          if y.get('id_promo') == str(nID).zfill(6)
                                         and y.get('sequencia_item') == maior_item.get('seq') else 0,
                                self.parent.list_itens_desconto_promo)
                    indice += 1
                else:
                    while indice < len(RsPromo1):
                        if RsPromo1[indice].get('id_promocao') <> nID:
                            break

                        indice += 1

        return True
