#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.cad_promo3p_data import CaixaCadPromo3p # deve ficar para executar 'eval()' no search
from sigpdv.models.db_utils import exec_sql
from decimal import Decimal
from datetime import datetime

TWOPLACES = Decimal(10) ** -2
TREPLACES = Decimal(10) ** -3


class CadPromo3p(object):
    def __init__(self, parent):
        self.parent = parent

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    filters += ".filter(CaixaCadPromo3p.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaCadPromo3p.%s == %s)" % (key, value)

            query = 'CaixaCadPromo3p.query%s' % filters
            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()

        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def calcula_promocao3(self):
        capa_id = self.parent.mov_capa.id
        indice = 0
        nItens = 0
        nItens1 = 0
        nDesconto = 0.0
        x = 0
        nQtde = 0
        nFez = 0
        ValDsc = 0.0
        DataPesq = ''
        sFilter = ''
        nSeq = 0
        PctsPai = 0
        Pacotes = 0
        varQtde = 0.0
        nCond = 0
        DescontoPack = 0.0
        lNaoPode = False
        MaxPcts = 0
        lTestar = False
        PctsOR = 0
        MaxPctOR = 0
        QualSeq = ''
        nConta = 0
        QualItem = ''
        vPcts = 0
        nElementos = 0
        PctsFilho = 0
        errPromo = False
        MaxPromo = 0.0
        
        DataPesq = str(datetime.now())[:19]
        sql = '''SELECT cpc.id                            AS promo_capa_id,
                        cpc.supproc_id_promo              AS id_promocao,
                        cpc.supproc_tipo_promo,
                        cpc.supproc_maximo                AS maximo,
                        cpc.supproc_scanntech             AS tipo_promo,
                        cpc.supproc_finalizadora_dinheiro AS somente_dineheiro,
                        cp3.suppro3p_barras               AS barras,
                        cp3.suppro3p_quantidade           AS quantidade,
                        cp3.suppro3p_sequencial           AS sequencial
                 FROM caixa_cad_promo_capa    AS cpc
                 INNER JOIN caixa_cad_promo3p AS cp3 ON cp3.suppro3p_capa_id = cpc.id
                 WHERE cpc.supproc_data_hora_inicio <= '{data}' at time zone 'UTC'
                   AND cpc.supproc_data_hora_fim >= '{data}' at time zone 'UTC'
                 ORDER BY cpc.supproc_id_promo, cp3.suppro3p_sequencial
                 '''.format(data=DataPesq)
        RsPromo3P = exec_sql(sql, 'C')
        if RsPromo3P:
            while indice < len(RsPromo3P):
                nCond = 0
                QtdProd = []
                Filtros = []
                MaxPcts = 10000
                nID = RsPromo3P[indice].get('id_promocao')
                promo_capa_id = RsPromo3P[indice].get('promo_capa_id')
                nSeq = RsPromo3P[indice].get('sequencial')
                MaxPromo = RsPromo3P[indice].get('maximo')
                errPromo = False
                lNaoPode = False
                DescontoPack = 0
                sFilter = """supcor_capa_id = {capa_id}
                         AND supcor_venda_cancelamento='V'  
                         AND supcor_desconto_item < 0.01 
                         AND supcor_acrescimo_item < 0.01 
                         AND (supcor_item='""".format(capa_id=capa_id) + RsPromo3P[indice].get('barras') + "'"
                indice += 1
                while indice < len(RsPromo3P):
                    if RsPromo3P[indice].get('id_promocao') <> nID:
                        break
                    if RsPromo3P[indice].get('sequencial') == nSeq:
                        sFilter = sFilter + " OR supcor_item='" + RsPromo3P[indice].get('barras') + "'"
                    else:
                        nSeq = RsPromo3P[indice].get('sequencial')
                        indice -= 1
                        sFilter = sFilter + ")"
                        sql = "SELECT SUM(supcor_quantidade) AS nqtde FROM caixa_mov_corpos WHERE " + sFilter
                        TmpItens = exec_sql(sql, 'C')
                        if TmpItens:
                            nItens = TmpItens[0].get('nqtde')  #Quantos itens encontrou do pai
                            if nItens >= RsPromo3P[indice].get('quantidade'):
                                QtdProd.append(RsPromo3P[indice].get('quantidade'))         # Quantos produtos dessa condicao s�o usados no pack
                                Filtros.append(sFilter)                                     # Filtro dessa condicao
                                Pacotes = int(nItens / RsPromo3P[indice].get('quantidade')) # Quantos pacotes consigo formas pra essa condi��o
                                nCond = nCond + 1                                           # Soma numero de condicoes
                                if Pacotes < MaxPcts: 
                                    MaxPcts = Pacotes    # Vamos guardar a menor qtd de packs dentre as condicoes
                            else:
                                lNaoPode = True
                                indice += 1
                                break
                            
                        else:
                            lNaoPode = True
                            indice += 1
                            break
                        
                        indice += 1
                        sFilter = """supcor_capa_id = {capa_id}
                                 AND supcor_venda_cancelamento='V'  
                                 AND supcor_desconto_item < 0.01 
                                 AND supcor_acrescimo_item < 0.01 
                                 AND (supcor_item='""".format(capa_id=capa_id) + RsPromo3P[indice].get('barras') + "'"
                    
                    indice += 1
                    
                if lNaoPode == False:  # Da pra fazer pack
                    indice -= 1
                    sFilter = sFilter + ")"
                    sql = "SELECT SUM(supcor_quantidade) as nqtde FROM caixa_mov_corpos WHERE " + sFilter
                    TmpItens = exec_sql(sql, 'C')
                    if TmpItens:
                        nItens = TmpItens[0].get('nqtde') # Quantos itens encontrou do pai
                        if nItens >= RsPromo3P[indice].get('quantidade'):
                            QtdProd.append(RsPromo3P[indice].get('quantidade'))         # Quantos produtos dessa condicao s�o usados no pack
                            Filtros.append(sFilter)                                     # Filtro dessa condi��o
                            Pacotes = int(nItens / RsPromo3P[indice].get('quantidade')) # Quantos pacotes consigo formas pra essa condi��o
                            nCond = nCond + 1                                           # Soma numero de condi��es
                            if Pacotes < MaxPcts: 
                                MaxPcts = Pacotes                     #Vamos guardar a menor qtd de packs dentre as condi��es
                        else:
                            lNaoPode = True
                        
                    else:
                        lNaoPode = True
                    
                    if lNaoPode == False:
                        MaxPcts = MaxPromo if MaxPcts > MaxPromo else MaxPcts
                        sql = '''SELECT cpc.supproc_id_promo              AS id_promocao,
                                        cpc.supproc_tipo_promo,
                                        cpc.supproc_maximo                AS maximo,
                                        cpc.supproc_scanntech             AS tipo_promo,
                                        cpc.supproc_finalizadora_dinheiro AS somente_dineheiro,
                                        cp3.suppro3f_barras               AS barras,
                                        cp3.suppro3f_quantidade           AS quantidade,
                                        cp3.suppro3f_desconto             AS desconto,
                                        cp3.suppro3f_tipo_desconto        AS tipodesc
                                 FROM caixa_cad_promo_capa    AS cpc
                                 INNER JOIN caixa_cad_promo3f AS cp3 ON cp3.suppro3f_capa_id = cpc.id
                                 WHERE cpc.id = {capa_id}
                                 ORDER BY cpc.supproc_id_promo
                                 '''.format(capa_id=promo_capa_id)
                        RsPromo3F = exec_sql(sql, 'C')
                        indice_3f = 0
                        if RsPromo3F:
                            sFilter = """supcor_capa_id = {capa_id}
                                 AND supcor_venda_cancelamento='V'  
                                 AND supcor_desconto_item < 0.01 
                                 AND supcor_acrescimo_item < 0.01 
                                 AND (supcor_item='""".format(capa_id=capa_id) + RsPromo3F[indice_3f].get('barras') + "'"
                            indice_3f += 1
                            while indice_3f < len(RsPromo3F):
                                sFilter = sFilter + " OR supcor_item='" + RsPromo3F[indice_3f].get('barras') + "'"
                                indice_3f += 1
                            
                            indice_3f -= 1
                            sFilter = sFilter + ")"
                            sql = "SELECT SUM(supcor_quantidade) AS nqtde FROM caixa_mov_corpos WHERE " + sFilter
                            ItensTmp = exec_sql(sql, 'C')
                            if ItensTmp:
                                nItens1 = ItensTmp[0].get('nqtde')
                                if nItens1 >= RsPromo3F[indice_3f].get('quantidade'):
                                    PctsFilho = int(nItens1 / RsPromo3F[indice_3f].get('quantidade'))
                                    Pacotes = PctsFilho if MaxPcts >= PctsFilho else MaxPcts
                                    
                                    sql = "SELECT * FROM caixa_mov_corpos WHERE " + sFilter + " Order By supcor_sequencia"
                                    ItensTmp = exec_sql(sql, 'C')
                                    indice_corpos_f = 0
                                    nFez = 0
                                    nQtde = (RsPromo3F[indice_3f].get('quantidade') * Pacotes)
                                    print 'Primeiro o filho...'
                                    while indice_corpos_f < len(ItensTmp):
                                        if RsPromo3F[indice_3f].get('tipodesc') == "$":
                                            ValDsc = RsPromo3F[indice_3f].get('desconto')
                                        else:
                                            ValDsc = Decimal((ItensTmp[indice_corpos_f].get('supcor_preco_unitario') *
                                                              RsPromo3F[indice_3f].get('desconto') / 100))
                                        
                                        if ItensTmp[indice_corpos_f].get('supcor_quantidade') >= (nQtde - nFez):
                                            nDesconto = ValDsc * (nQtde - nFez)
                                            varQtde = (nQtde - nFez)
                                            nFez = nFez + (nQtde - nFez)
                                        else:
                                            nDesconto = ValDsc * ItensTmp[indice_corpos_f].get('supcor_quantidade')
                                            varQtde = ItensTmp[indice_corpos_f].get('supcor_quantidade')
                                            nFez = nFez + ItensTmp[indice_corpos_f].get('supcor_quantidade')
                                        
                                        if nDesconto > 0 and nDesconto < ItensTmp[indice_corpos_f].get('supcor_preco_total'):
                                            self.parent.list_itens_desconto_promo.append(
                                            {'sequencia_item':ItensTmp[indice_corpos_f].get('supcor_sequencia'),
                                             'desconto': nDesconto.quantize(TWOPLACES),
                                             'id_promo': str(nID).zfill(6),
                                             'quantidade': varQtde,
                                             'tipo_promo': '1' if RsPromo3F[indice_3f].get('tipo_promo') else '2',
                                             'somente_dinheiro': RsPromo3F[indice_3f].get('somente_dineheiro'),
                                            })
                                        else:
                                            Log.info("Desconto Inválido. Promoção-3: " + str(nID).zfill(6))
                                            promo_delete = filter(lambda y: y.get('id_promo') == str(nID).zfill(6)
                                                              and y.get('id_promo') == '3', self.parent.list_itens_desconto_promo)
                                            map(lambda x: self.parent.list_itens_desconto_promo.remove(x), promo_delete)
                                            errPromo = True
                                            break
                                        
                                        indice_corpos_f += 1
                                        if str(nQtde).zfill(5) == str(nFez).zfill(5):
                                            break

                                    if not errPromo:
                                        print 'Agora o pai...'
                                        for x in range(len(Filtros)):
                                            sql = "SELECT * FROM caixa_mov_corpos WHERE " + Filtros[x] + " Order By supcor_sequencia"
                                            TmpItens = exec_sql(sql, 'C')
                                            indice_corpos_p = 0
                                            nFez = 0
                                            #nQtde = (QtdProd[x] * MaxPcts)
                                            nQtde = (QtdProd[x] * Pacotes)
                                            while indice_corpos_p < len(TmpItens):
                                                if TmpItens[indice_corpos_p].get('supcor_quantidade') >= (nQtde - nFez):
                                                    nDesconto = Decimal(0)
                                                    varQtde = (nQtde - nFez)
                                                    nFez = nFez + (nQtde - nFez)
                                                else:
                                                    nDesconto = Decimal(0)
                                                    varQtde = TmpItens[indice_corpos_p].get('supcor_quantidade')
                                                    nFez = nFez + TmpItens[indice_corpos_p].get('supcor_quantidade')
                                                

                                                self.parent.list_itens_desconto_promo.append(
                                                {'sequencia_item':TmpItens[indice_corpos_p].get('supcor_sequencia'),
                                                 'desconto': nDesconto.quantize(TWOPLACES),
                                                 'id_promo': str(nID).zfill(6),
                                                 'quantidade': varQtde,
                                                 'tipo_promo': '1' if RsPromo3P[indice].get('tipo_promo') else '2',
                                                 'somente_dinheiro': RsPromo3P[indice].get('somente_dineheiro'),
                                                })
                                                indice_corpos_p += 1
                                                if str(nQtde).zfill(5) == str(nFez).zfill(5):
                                                    break

                    indice += 1
                else:
                    while indice < len(RsPromo3P):
                        if RsPromo3P[indice].get('id_promocao') <> nID: break
                        indice += 1

        return True
