#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.cad_promo6_data import CaixaCadPromo6 # deve ficar para executar 'eval()
from sigpdv.models.db_utils import exec_sql
from datetime import datetime
from decimal import Decimal

TWOPLACES = Decimal(10) ** -2


class CadPromo6(object):
    def __init__(self, parent):
        self.parent = parent

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = []
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str]:
                    filters += ".filter(CaixaCadPromo6.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaCadPromo6.%s == %s)" % (key, value)

            query = 'CaixaCadPromo6.query%s' % filters
            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()

        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def calcula_promocao6(self):
        capa_id = self.parent.mov_capa.id
        indice = 0
        nItens = 0
        nDesconto = 0.0
        x = 0
        nQtde = 0
        nFez = 0
        ValDsc = 0.0
        Agora = ''
        DataPesq = ''
        sFilter = ''
        varQtde = 0.0
        varQtde1 = 0.0
        nPrecisa = 0
        nFez1 = 0
        nSeq = 0
        lNaoPode = False
        MaxPromo = 0.0
        
        DataPesq = str(datetime.now())[:19]
        sql = ''' SELECT cpc.supproc_id_promo              AS id_promocao,
                         cpc.supproc_tipo_promo,
                         cpc.supproc_maximo                AS maximo,
                         cpc.supproc_scanntech             AS tipo_promo,
                         cpc.supproc_finalizadora_dinheiro AS somente_dineheiro,
                         cp6.suppro6_barras                AS barras,
                         cp6.suppro6_qtd_leva              AS qtd_leva,
                         cp6.suppro6_qtd_paga              AS qtd_paga,
                         cp6.suppro6_sequencial            AS sequencial                         
                 FROM caixa_cad_promo_capa   AS cpc
                 INNER JOIN caixa_cad_promo6 AS cp6 ON cp6.suppro6_capa_id = cpc.id
                 WHERE cpc.supproc_data_hora_inicio <= '{data}' at time zone 'UTC'
                   AND cpc.supproc_data_hora_fim >= '{data}' at time zone 'UTC'
                 ORDER BY cpc.supproc_id_promo, cp6.suppro6_sequencial
                 '''.format(data=DataPesq)
        RsPromo6 = exec_sql(sql, 'C')
        if RsPromo6:
            while indice < len(RsPromo6):
                nFez = 0
                nFez1 = 0
                nDesconto = 0
                lNaoPode = False
                nID = RsPromo6[indice].get('id_promocao')
                nSeq = RsPromo6[indice].get('sequencial')
                MaxPromo =RsPromo6[indice].get('maximo')
                sFilter = """supcor_capa_id = {capa_id}
                         AND supcor_venda_cancelamento='V'
                         AND supcor_desconto_item < 0.01
                         AND supcor_acrescimo_item < 0.01
                         AND (supcor_item='""".format(capa_id=capa_id) + RsPromo6[indice].get('barras') + "'"
                indice += 1
                while indice < len(RsPromo6):
                    if RsPromo6[indice].get('id_promocao') <> nID: 
                        break
                        
                    sFilter += """ OR supcor_item='""" + RsPromo6[indice].get('barras') + "'"
                    indice += 1
                
                indice -= 1
                sFilter = sFilter + ")"
                sql = "SELECT SUM(supcor_quantidade) AS nqtde FROM caixa_mov_corpos WHERE " + sFilter
                TmpItens = exec_sql(sql, 'C')
                if TmpItens:
                    if TmpItens[0].get('nqtde') >= RsPromo6[indice].get('qtd_leva'):
                        nQtde = int(TmpItens[0].get('nqtde') / RsPromo6[indice].get('qtd_leva'))
                        nQtde = MaxPromo if nQtde > MaxPromo else nQtde
                        nPrecisa = RsPromo6[indice].get('qtd_leva') * nQtde
                        nQtde = (RsPromo6[indice].get('qtd_leva') -
                                 RsPromo6[indice].get('qtd_paga')) * nQtde # Quantos itens vai levar com preco=0.01

                        sql = "SELECT * FROM caixa_mov_corpos WHERE " + sFilter + " ORDER BY supcor_quantidade DESC"
                        TmpItens = exec_sql(sql, 'C')
                        indice_corpos = 0
                        while indice_corpos < len(TmpItens):
                            if TmpItens[indice_corpos].get('supcor_quantidade') > (nQtde - nFez):
                                nDesconto = (TmpItens[indice_corpos].get('supcor_preco_unitario') * (nQtde - nFez))
                                varQtde = nQtde - nFez
                            else:
                                nDesconto = (TmpItens[indice_corpos].get('supcor_preco_unitario') *
                                             TmpItens[indice_corpos].get('supcor_quantidade')) - Decimal(0.01)
                                varQtde = TmpItens[indice_corpos].get('supcor_quantidade')
                            
                            if TmpItens[indice_corpos].get('supcor_quantidade') > (nPrecisa - nFez1):
                                varQtde1 = nPrecisa - nFez1
                            else:
                                varQtde1 = TmpItens[indice_corpos].get('supcor_quantidade')
                            
                            nFez1 = nFez1 + varQtde1
                            nFez = nFez + varQtde
                            self.parent.list_itens_desconto_promo.append(
                                    {'sequencia_item':TmpItens[indice_corpos].get('supcor_sequencia'),
                                     'desconto': nDesconto.quantize(TWOPLACES),
                                     'id_promo': str(nID).zfill(6),
                                     'quantidade': varQtde1,
                                     'tipo_promo': '1' if RsPromo6[indice].get('tipo_promo') else '2',
                                     'somente_dinheiro': RsPromo6[indice].get('somente_dineheiro'),
                                    })
                            indice_corpos += 1
                            if str(nQtde).zfill(5) == str(nFez).zfill(5):
                                break
                        
                        if nFez1 < nPrecisa:
                            while indice_corpos < len(TmpItens):
                                if TmpItens[indice_corpos].get('supcor_quantidade') > (nPrecisa - nFez1):
                                    varQtde = nPrecisa - nFez1
                                    nDesconto = Decimal(0)
                                else:
                                    varQtde = TmpItens[indice_corpos].get('supcor_quantidade')
                                    nDesconto = Decimal(0)
                                
                                nFez1 = nFez1 + varQtde
                                
                                self.parent.list_itens_desconto_promo.append(
                                    {'sequencia_item':TmpItens[indice_corpos].get('supcor_sequencia'),
                                     'desconto': nDesconto.quantize(TWOPLACES),
                                     'id_promo': str(nID).zfill(6),
                                     'quantidade': varQtde,
                                     'tipo_promo': '1' if RsPromo6[indice].get('tipo_promo') else '2',
                                     'somente_dinheiro': RsPromo6[indice].get('somente_dineheiro'),
                                    })
                                if str(nPrecisa).zfill(5) == str(nFez1).zfill(5):
                                    break

                                indice_corpos += 1

                indice += 1

        return  True
