#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import date, datetime
from PySide import QtGui
from sigpdv.control.mov_capa import MovCapa
from sigpdv.control.mov_cupom_servidor import MovCupomServidor
from sigpdv.tools.log import traced as Log
from sigpdv.ui.messagebox import MSG_ERROR, message_dlg

class Lmfd(object):
    def __init__(self, parent):
        self.parent = parent
        
    @Log
    def gravar_lmfd(self,loja, caixa, operador_id):
        try:
            self.parent.obj_fiscal_printer
            data_ini = self.parent.obj_fiscal_printer.get_data_ecf()
            data_cupom = datetime.date(self.parent.obj_fiscal_printer.get_data_ecf())
            if not data_cupom or str(data_cupom) == '2000-01-01':
                data_cupom = date.today()

            coo = int(self.parent.obj_fiscal_printer.send_command("get_coo()"))

            self.parent.obj_fiscal_printer.printer._port.setTimeout(15)
            # Grava a capa do cupom
            dados_capa = dict(supcap_data_cupom=data_cupom,
                              supcap_loja=loja,
                              supcap_caixa=caixa,
                              supcap_nro_cupom=coo,
                              supcap_data_inicio=data_ini,
                              supcap_data_fim=data_ini,
                              supcap_tipo='M',
                              supcap_nro_proprietario=loja)
            if operador_id:
                dados_capa['supcap_operador_id'] = operador_id

            self.parent.mov_capa = MovCapa().create(dados_capa)
            self.parent.obj_fiscal_printer.printer._port.setTimeout(1) # apos gravar o cupom o timeout volta para 1
            if not self.parent.mov_capa:
                return message_dlg(self.parent, MSG_ERROR, 'Não foi possível gravar o cupom no banco!')

            # Grava cupom servidor
            MovCupomServidor().create({'supcse_capa_id': self.parent.mov_capa.id})
            QtGui.QApplication.processEvents()

        except Exception as e:
            Log.error(str(e))
            self.parent.show_info_proccess(False)
            return False

        self.parent.show_info_proccess(False)
        return True
        