#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.mov_caixa_data import CaixaMovCaixa
from sigpdv.models.db_utils import sess, exec_sql
from datetime import datetime, date


class MovCaixa():
    def __init__(self):
        pass

    @staticmethod
    def get_data_hora_abertura(loja, caixa, mov_caixa_id):
        sql = """
            SELECT mov_caixa.supcax_data_hora_abertura
            FROM   caixa_mov_caixa mov_caixa
                   INNER JOIN caixa_cad_operadores cad_operadores
                           ON mov_caixa.supcax_operador_id = cad_operadores.id
            WHERE  mov_caixa.id = %d
                   AND mov_caixa.supcax_loja = %d
                   AND mov_caixa.supcax_caixa = %d
                   AND mov_caixa.supcax_fechado = 'A'

        """ % (mov_caixa_id, loja, caixa)

        data_mov = exec_sql(sql, 'C', ret=True)
        if data_mov and isinstance(data_mov, list):
            data_mov = data_mov[0]['supcax_data_hora_abertura']
        return data_mov

    @Log
    def search(self, vals, order_by=None, limit=0):
        res = False
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    filters += ".filter(CaixaMovCaixa.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaMovCaixa.%s == %s)" % (key, value)

            query = "CaixaMovCaixa.query%s" % filters

            if order_by:
                query += ".order_by('%s')" % order_by

            if limit:
                query += ".limit(%s)" % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()
        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def create(self, vals):
        res = False
        try:
            values = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    values += "%s='%s', " % (key, value)
                else:
                    values += "%s=%s, " % (key, value)
            sess.begin()
            res = eval("CaixaMovCaixa(%s)" % values)
            sess.commit()
        except Exception as err:
            sess.rollback()
            Log.error('Erro ao gravar Abertura/Fechamento de Turno! \n%s' % str(err))

        return res

    @Log
    def write(self, query_caixa, vals):
        res = False
        try:
            sess.begin()
            query_caixa.from_dict(vals)
            sess.commit()
            res = True
        except Exception as err:
            sess.rollback()
            Log.error(str(err))

        return res
