#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.mov_kits_cupom_data import CaixaMovkitsCupom
from sigpdv.models.db_utils import sess
from sigpdv.control.fiscal_printer import FiscalPrinterHelper
from datetime import datetime, date


class MovkitsCupom():
    def __init__(self):
        pass

    @Log
    def search(self, vals, order_by=None, limit=0):
        res = False
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    filters += ".filter(CaixaMovkitsCupom.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaMovkitsCupom.%s == %s)" % (key, value)

            query = 'CaixaMovkitsCupom.query%s' % filters

            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()
        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def create(self, vals):
        try:
            values = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    values += "%s='%s', " % (key, value)
                else:
                    values += "%s=%s, " % (key, value)

            sess.begin()
            res = eval("CaixaMovkitsCupom(%s)" % values)
            sess.commit()
            return res
        except Exception as err:
            sess.rollback()
            Log.error('Erro ao gravar Kit vendido no cupom! \n%s' % str(err))
            return False

    @Log
    def write(self, query_kits_cupom, vals):
        res = False
        try:
            sess.begin()
            query_kits_cupom.from_dict(vals)
            sess.commit()
            res = True
        except Exception as err:
            sess.rollback()
            Log.error(str(err))

        return res

