#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.mov_vencimentos_data import CaixaMovVencimentos
from sigpdv.models.db_utils import sess
from datetime import datetime, date


class MovVencimentos():
    def __init__(self):
        pass

    @staticmethod
    def search(vals, order_by=None, limit=0):
        res = False
        try:
            filters = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    filters += ".filter(CaixaMovVencimentos.%s == '%s')" % (key, value)
                else:
                    filters += ".filter(CaixaMovVencimentos.%s == %s)" % (key, value)

            query = 'CaixaMovVencimentos.query%s' % filters

            if order_by:
                query += '.order_by(%s)' % order_by

            if limit:
                query += '.limit(%s)' % limit

            res_query = eval(query)
            if res_query.count():
                if res_query.count() == 1:
                    res = res_query.one()
                else:
                    res = res_query.all()
        except Exception as err:
            res = False
            Log.error(str(err))

        return res

    @Log
    def create(self, vals):
        res = False
        try:
            values = ''
            for key in vals:
                value = vals[key]
                if type(value) in [unicode, str, date, datetime]:
                    values += "%s='%s', " % (key, value)
                else:
                    values += "%s=%s, " % (key, value)
            sess.begin()
            res = eval("CaixaMovVencimentos(%s)" % values)
            sess.commit()
        except Exception as err:
            sess.rollback()
            Log.error('Erro ao gravar Vencimentos do Cupom! \n%s' % str(err))

        return res

    @Log
    def write(self, query_vencimentos, vals):
        res = False
        try:
            sess.begin()
            query_vencimentos.from_dict(vals)
            sess.commit()
            res = True
            res = True
        except Exception as err:
            sess.rollback()
            Log.error(str(err))

        return res
