#!/bin/bash

echo ""
echo "libswmfd.so"
echo "Versão 1.27.5.0  Dezembro/2010"
   
case $1 in 
"LD")
   echo "Ligação dinâmica da biblioteca 'libswmfd.so'"
   g++ -Wall -g -c "exemplo.c" -o "exemplo.o"
   g++ -o exemplo -lpthread ".libs/libswmfd.so.0" -Wl,--rpath -Wl,".libs" exemplo.o 
;;
"")
   echo "Carregamento dinâmico da biblioteca 'libswmfd.so'"
   g++ -DCARREGAMENTO_DINAMICO -Wall -g -fno-strict-aliasing -c "exemplo.c" -o "exemplo.o"
   g++ -o exemplo exemplo.o -lpthread -ldl
;;
*)
   echo "Para ligação dinâmica da libswmfd.so, utilize a opção LD: ./make.sh LD"
   echo "Para carregamento dinâmico da libswmfd.so apenas ./make.sh (opção padrão)"
   echo "Ligação estática não disponível!"
   echo ""
esac

echo ""

