
/*
Arquivo: swmfd_dl.c

   ÍNDICE:
      1. Definição do nome do arquivo de ligação dinâmica
      2. Rotina de carregamento dinâmico da biblioteca
      3. Rotina de descarregamento dinâmico da biblioteca
*/
#ifdef CARREGAMENTO_DINAMICO

#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include "swmfd.h"


// 1. Definição do nome do arquivo de ligação dinâmica

#define ARQUIVO_DE_LIGACAO_DINAMICA  ".libs/libswmfd.so.0"
  

// Handle para o arquivo .so
void *hSWMFD = NULL;


// 2. Rotina de carregamento dinâmico da biblioteca

void SWMFD_LoadLibrary ()
{  if (hSWMFD)
      return;
   
#define GetAddressOf(Label) \
  (((* (int**) &Label) = (int*) dlsym (hSWMFD, #Label)) != NULL)

   if ((hSWMFD = dlopen (ARQUIVO_DE_LIGACAO_DINAMICA, RTLD_LAZY)) != NULL &&
	   GetAddressOf (SWEDA_SWMFDVersao) &&
	   GetAddressOf (SWEDA_ExtrairInformacoesECF) &&
	   GetAddressOf (SWEDA_ArquivoSINTEGRA) &&
	   GetAddressOf (SWEDA_ReproduzirLeituraMemoriaFiscal) &&
	   GetAddressOf (SWEDA_ReproduzirFitaDetalhe) &&
	   GetAddressOf (SWEDA_ArquivoEletronicoCOTEPE) &&
	   GetAddressOf (SWEDA_CapturarDispositivo) &&
	   GetAddressOf (SWEDA_DetectarECF) &&
	   GetAddressOf (SWEDA_TabelaMercadoriasServicos) &&
	   GetAddressOf (SWEDA_EmitirLeituraX) &&
	   GetAddressOf (SWEDA_EmitirLeituraMemoriaFiscal) &&
	   GetAddressOf (SWEDA_EmitirLeituraParametros) &&
	   GetAddressOf (SWEDA_ImprimirFitaDetalhe) &&
	   GetAddressOf (SWEDA_ConectarECF) &&
	   GetAddressOf (SWMFD_ObterParametrosConfiguracao) &&
	   GetAddressOf (SWMFD_AlterarParametrosConfiguracao) &&
	   GetAddressOf (SWMFD_AbrirPortaFiscal) &&
	   GetAddressOf (SWMFD_FecharPortaFiscal))
      return;
   
   fputs (dlerror(), stderr);
   exit (1);  
}


// 3. Rotina de descarregamento dinâmico da biblioteca

void SWMFD_FreeLibrary()
{  if (hSWMFD)
      dlclose (hSWMFD);
}

#else

void SWMFD_LoadLibrary() { }
void SWMFD_FreeLibrary() { }

#endif
