#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import String, Integer, VARCHAR


class CaixaCadMunicipios(Entity):
    """
    Tabela de Cadastro de municipios
    Prefixo: supmun
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_municipios')
    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supmun_codigo_ibge = Field(VARCHAR(45))
    supmun_iduf = Field(Integer)
    name = Field(String(100))

    def __repr__(self):
        _repr = "<caixa_cad_municipios: %d - %d, %s'>"
        vals = self.id, self.supmun_iduf, self.name
        return _repr % vals