#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import SmallInteger, Integer, \
     ForeignKey, DECIMAL, CHAR


class CaixaCadPromo6(Entity):
    """
    Tabela de Cadastro de promocoes
    Prefixo: suppro6
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_promo6')

    id = Field(Integer(11), primary_key=True, autoincrement=True, index=True)
    suppro6_capa_id = Field(Integer(11),
                            ForeignKey('caixa_cad_promo_capa.id', ondelete="cascade"), required=True,
                            index=True)
    suppro6_barras = Field(CHAR(14))
    suppro6_qtd_leva = Field(DECIMAL(10, 3))
    suppro6_qtd_paga = Field(DECIMAL(10, 3))
    suppro6_sequencial = Field(SmallInteger(2), index=True)
    

    def __repr__(self):
        _repr = "<caixa_cad_promo_capa: %s, 'Codigo de barra=%s'>"
        vals = self.suppro6_capa_id, self.suppro6_barras
        return _repr % vals