#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Boolean, DateTime, Integer, \
    UniqueConstraint, CHAR


class CaixaCadPromoCapa(Entity):
    """
    Tabela de Cadastro de promocoes
    Prefixo: supproc
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_promo_capa')

    id = Field(Integer(11), primary_key=True, autoincrement=True, index=True)
    supproc_data_hora_inicio = Field(DateTime, index=True)
    supproc_data_hora_fim = Field(DateTime, index=True)
    supproc_id_promo = Field(Integer(11), index=True)
    supproc_tipo_promo = Field(CHAR(1))
    supproc_maximo = Field(Integer(11))
    supproc_scanntech = Field(Boolean) # True a promocao eh Scanntech, False a promocao eh Sig
    supproc_finalizadora_dinheiro = Field(Boolean)

    # _sql_constraints
    using_table_options(UniqueConstraint('supproc_id_promo', 'supproc_scanntech'))

    def __repr__(self):
        _repr = "<caixa_cad_promo_capa: %s, 'Data init.=%s', 'Data init.=%s'>"
        vals = self.supproc_id_promo, str(self.supproc_data_hora_inicio), str(self.supproc_data_hora_fim)
        return _repr % vals