#!/usr/bin/python
# -*- coding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Boolean, Integer, UniqueConstraint, CHAR


class CaixaCadResticaoItem(Entity):
    """
    Tabela de Cadastro de restricoes de itens
    Prefixo: supres
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_restricao_item')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supres_codigo_barra = Field(CHAR(14), index=True)
    supres_nome_item = Field(CHAR(60))
    supres_max = Field(Integer(11))
    supres_solicita_sup = Field(Boolean)

    # _sql_constraints
    using_table_options(UniqueConstraint('supres_codigo_barra'))

    def __repr__(self):
        _repr = "<caixa_cad_restricao_item_id: %s, 'CB=%s', 'ITEM=%s'>"
        vals = self.id, str(self.supres_codigo_barra), str(self.supres_nome_item)
        return _repr % vals