#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Integer, String, DateTime, DECIMAL, VARCHAR, CHAR, UniqueConstraint


class CaixaCadTributacao(Entity):
    """
    Tabela de Tributacao
    Prefixo: suptri
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_tributacao')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    suptri_codigo_trib_ecf = Field(String(3))
    suptri_name = Field(String(30))
    suptri_codigo_trib_retag = Field(VARCHAR(6))
    suptri_aliquota = Field(DECIMAL(5, 2))
    suptri_base = Field(DECIMAL(5, 2))
    suptri_tipo_imposto = Field(CHAR(1))
    suptri_tipo_tributacao = Field(CHAR(1))
    last_update = Field(DateTime, default=datetime.now())

    # _sql_constraints
    using_table_options(UniqueConstraint('suptri_codigo_trib_ecf'))

    def __repr__(self):
        _repr = "<caixa_cad_tributacao: %s, 'CodigoTribEcf=%s', 'TribRetag=%s'>"
        vals = self.suptri_name, self.suptri_codigo_trib_ecf, self.suptri_codigo_trib_retag
        return _repr % vals