#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Integer, VARCHAR, DateTime


class CaixaCadVendedor(Entity):
    """
    Tabela de Vendedores
    Prefixo: supven
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cad_vendedor')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supven_codigo = Field(Integer, primary_key=True, autoincrement=False)
    name = Field(VARCHAR(40), required=True)
    last_update = Field(DateTime, default=datetime.now())

    def __repr__(self):
        _repr = "<caixa_cad_Vendedor: %s-%s'>"
        vals = self.supven_codigo, self.name
        return _repr % vals