#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import SmallInteger, String, Float, Integer


class CaixaCfgConfiguracao(Entity):
    """
    Tabela de configuracao
    Prefixo: supcfc
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cfg_configuracao')
    using_table_options(useexisting=True)

    supcfc_loja = Field(SmallInteger(6))
    supcfc_cnpj = Field(String(15))
    supcfc_cliente = Field(String(40))
    supcfc_endereco = Field(String(40))
    supcfc_cidade = Field(String(30))
    supcfc_estado = Field(String(2))
    supcfc_cep = Field(String(8))
    supcfc_nro_serie = Field(String(5))
    supcfc_data_validade = Field(String(8))
    supcfc_inscricao_estadual = Field(String(20))
    supcfc_fax = Field(String(14))
    supcfc_telefone = Field(String(14))
    supcfc_diretorio_importacao = Field(String(100))
    supcfc_numero = Field(SmallInteger(5))
    supcfc_complemento = Field(String(20))
    supcfc_bairro = Field(String(15))
    supcfc_responsavel = Field(String(25))
    supcfc_ultimo_acesso = Field(String(8))
    supcfc_inscricao_municipal = Field(String(20))
    supcfc_cidade_ibge = Field(String(7))
    supcfc_fantasia = Field(String(40))
    supcfc_contador_nome = Field(String(40))
    supcfc_contador_cpf = Field(String(11))
    supcfc_contador_crc = Field(String(15))
    supcfc_contador_cnpj = Field(String(14))
    supcfc_contador_cep = Field(Integer(11))
    supcfc_contador_end = Field(String(40))
    supcfc_contador_end_nro = Field(Integer(11))
    supcfc_contador_end_compl = Field(String(20))
    supcfc_contador_end_bairro = Field(String(30))
    supcfc_contador_end_mun_ibge = Field(Integer(11))
    supcfc_contador_fone = Field(String(10))
    supcfc_contador_fax = Field(String(10))
    supcfc_contador_email = Field(String(40))
    supcfc_pis = Field(Float(5, 4))
    supcfc_cofins = Field(Float(5, 4))

    def __repr__(self):
        _repr = "<caixa_cfg_Configuracao: %s, 'Loja=%d', 'Cliente=%s'"
        vals = self.supcfc_cnpj, self.supcfc_loja, self.supcfc_cliente
        return _repr % vals