#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Integer, String


class CaixaCfgMensagens(Entity):
    """
    Tabela de Mensagens
    Prefixo: supcfm
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cfg_mensagens')
    using_table_options(useexisting=True)

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supcfm_mensagem_1 = Field(String(40))
    supcfm_mensagem_2 = Field(String(40))

    def __repr__(self):
        _repr = "<caixa_cfg_mensagens: 'M1=%s', 'M2=%s'"
        vals = self.supcfm_mensagem_1, self.supcfm_mensagem_2
        return _repr % vals