#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy.sql.expression import text
from sqlalchemy import DateTime, Integer, SmallInteger, VARCHAR, DECIMAL, Boolean, Text


class CaixaCfgParametros(Entity):
    """
    Tabela de parametros do supervisor
    Prefixo: supcfp
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_cfg_parametros')
    using_table_options(useexisting=True)

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supcfp_moeda_singular = Field(VARCHAR(20))
    supcfp_moeda_plural = Field(VARCHAR(20))
    supcfp_municipio = Field(VARCHAR(30))
    supcfp_favorecido = Field(VARCHAR(40))
    supcfp_qtd_minima = Field(SmallInteger(6))
    supcfp_qtd_maxima = Field(SmallInteger(6))
    supcfp_valor_bonus = Field(DECIMAL(10, 2))
    supcfp_pz_sem_juros = Field(Integer(11))
    supcfp_pz_prazo1 = Field(SmallInteger(6))
    supcfp_pz_prazo2 = Field(SmallInteger(6))
    supcfp_pz_prazo3 = Field(SmallInteger(6))
    supcfp_pz_prazo4 = Field(SmallInteger(6))
    supcfp_pz_prazo5 = Field(SmallInteger(6))
    supcfp_pz_valor1 = Field(DECIMAL(10, 2))
    supcfp_pz_valor2 = Field(DECIMAL(10, 2))
    supcfp_pz_valor3 = Field(DECIMAL(10, 2))
    supcfp_pz_valor4 = Field(DECIMAL(10, 2))
    supcfp_pz_valor5 = Field(DECIMAL(10, 2))
    supcfp_pz_juros1 = Field(DECIMAL(10, 2))
    supcfp_pz_juros2 = Field(DECIMAL(10, 2))
    supcfp_pz_juros3 = Field(DECIMAL(10, 2))
    supcfp_pz_juros4 = Field(DECIMAL(10, 2))
    supcfp_pz_juros5 = Field(DECIMAL(10, 2))
    supcfp_limite_sangria = Field(DECIMAL(10, 2))
    supcfp_cliente_contra_vale = Field(Integer(11))
    supcfp_conta_contra_vale = Field(VARCHAR(15))
    supcfp_conta_transfer_contra_vale = Field(VARCHAR(15))
    supcfp_pre_permite_desconto = Field(VARCHAR(1))
    supcfp_pre_permite_acrescimo = Field(VARCHAR(1))
    supcfp_limite_cheque_a_vista = Field(DECIMAL(10, 2))
    supcfp_restringe_desconto = Field(Boolean, server_default=text('False'))
    supcfp_mensagem_doacao = Field(Text)
    last_update = Field(DateTime, default=datetime.now())
    supcfp_arq_promocoes = Field(VARCHAR(100)) # nao eh usado no frente, apenas no supervisor