#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import Boolean, Integer, CHAR, ForeignKey, Date, DECIMAL


class CaixaMovCorpoXZ(Entity):
    """
    Tabela complementar capa para X e Z
    Prefixo: supcxz
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_corpo_xz')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supcxz_data_movimento = Field(Date)
    supcxz_cro = Field(Integer(11))
    supcxz_cupom_inicial = Field(Integer(11))
    supcxz_cupom_final = Field(Integer(11))
    supcxz_gt_atual = Field(DECIMAL(18, 3))
    supcxz_gt_anterior = Field(DECIMAL(18, 3))
    supcxz_cancelamentos = Field(DECIMAL(16, 3))
    supcxz_descontos = Field(DECIMAL(16, 3))
    supcxz_parametro_desconto_iss = Field(Boolean)
    supcxz_acrescimos = Field(DECIMAL(16, 3))
    supcxz_modelo_ecf = Field(CHAR(20))
    supcxz_descontos_iss = Field(DECIMAL(16, 3))
    supcxz_acrescimos_iss = Field(DECIMAL(16, 3))
    supcxz_cancelamentos_iss = Field(DECIMAL(16, 3))
    supcxz_ccf = Field(Integer(11))
    supcxz_gnf = Field(Integer(11))
    supcxz_capa_id = Field(Integer(11), ForeignKey('caixa_mov_capa.id', onupdate="cascade",
                                                   ondelete="cascade"))
    scanntech = Field(Integer(11))

    def __repr__(self):
        _repr = "<caixa_mov_corpo_xz: %.3f, 'IdCapa=%d'>"
        vals = self.supcxz_gt_atual, self.supcxz_capa_id
        return _repr % vals