#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Boolean, Entity, Field
from elixir.options import using_options, using_table_options
from sqlalchemy import Integer, ForeignKey, UniqueConstraint


class CaixaMovCupomServidor(Entity):
    """
    Tabela de cupons exportados para o servidor
    Prefixo: supcse
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_cupom_servidor')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supcse_enviado = Field(Boolean)
    supcse_capa_id = Field(Integer(11), ForeignKey('caixa_mov_capa.id',
                                                   onupdate="cascade", ondelete="cascade"),
                           index=True)
    using_table_options(UniqueConstraint('supcse_capa_id'))

    def __repr__(self):
        _repr = "<caixa_mov_cupom_servidor: %s, 'capa_id=%d'>"
        vals = self.supcse_enviado, self.supcse_capa_id
        return _repr % vals