#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field, create_all, setup_all
from elixir.options import using_options
from sqlalchemy import Integer, String, DECIMAL


class CaixaMovkitsCupom(Entity):
    """
    Tabela de Kits de um cupom
    Os dados da tabela existem apenas quando o cupom está sendo vendido, apos o temino da venda ela eh deletada
    Prefixo: movkic
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_kits_cupom')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    movkic_codigo_barra_kit = Field(String(14), primary_key=True, autoincrement=False)
    movkic_quantidade = Field(DECIMAL(10, 3)) # quantidade vendida deste kit
    movkic_valor_kit = Field(DECIMAL(10, 3))
    movkic_total_itens = Field(DECIMAL(10, 3))

    def __repr__(self):
        _repr = "<caixa_mov_kits_cupom: %s, 'Cod. Kit=%s'>"
        vals = self.id, self.movkic_codigo_barra_kit,
        return _repr % vals