#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import CHAR, SmallInteger, Enum, Integer, String, Date, DECIMAL


class CaixaMovMeiosPagamentos(Entity):
    """
    Tabela Resumo de meios de pagamento
    Prefixo: supmpa
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_meios_pagamentos')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supmpa_loja = Field(SmallInteger(6))
    supmpa_caixa = Field(SmallInteger(6))
    supmpa_data_movimento = Field(Date)
    supmpa_finalizadora = Field(SmallInteger(6))
    supmpa_tipo_documento = Field(CHAR(2))
    supmpa_descricao_finalizadora = Field(String(100))
    supmpa_valor = Field(DECIMAL(10, 2))
    supmpa_enviado = Field(Enum('S', 'N', name='enviado'), default='N')

    def __repr__(self):
        _repr = "<caixa_mov_meios_pagamentos: %s, 'Loja=%d', 'Caixa=%d', 'Finalizadora=%s', " \
                "'Valor=R$ %.2f'>"
        vals = self.supmpa_data_movimento, self.supmpa_loja, self.supmpa_caixa, \
            self.supmpa_descricao_finalizadora, self.supmpa_valor
        return _repr % vals