#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import SmallInteger, Integer, String, CHAR, DateTime, Boolean, DECIMAL, text


class CaixaMovMesas(Entity):
    """
    Tabela de capa de Controle de Mesas
    Prefixo: supmes
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_mesas')

    id = Field(SmallInteger(6), primary_key=True, autoincrement=True)
    supmes_loja = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supmes_caixa = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supmes_num_mesa = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    active = Field(Boolean),
    supmes_transf_mesa = Field(SmallInteger(6), server_default=text('0')),
    supmes_nro_cupom = Field(Integer(11))
    supmes_status = Field(CHAR(1), server_default=text("'A'"))
    supmes_cliente = Field(String(15), server_default=text("''"))
    supmes_sub_total = Field(DECIMAL(10, 2), server_default=text('0'))
    supmes_data_hora_abertura = Field(DateTime(), default=datetime.now())
    supmes_data_hora_fechamento = Field(DateTime())
    supmes_observacao = Field(String(120))

    def __repr__(self):
        _repr = "<caixa_mov_mesas: %d, 'Status=%s', 'Data Abertura=%s'>"
        vals = self.id, self.supmes_status, self.supmes_data_hora_abertura
        return _repr % vals