#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import SmallInteger, String, DECIMAL, Date


class CaixaMovSaldo(Entity):
    """
    Tabela de Saldo
    Prefixo: supsal
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_saldo')

    supsal_loja = Field(SmallInteger(6), primary_key=True, autoincrement=False)
    supsal_item = Field(String(20), primary_key=True, autoincrement=False)
    supsal_saldo_inicial = Field(DECIMAL(16, 2))
    supsal_saldo = Field(DECIMAL(16, 2))
    supsal_data = Field(Date)

    def __repr__(self):
        _repr = "<caixa_mov_saldo: 'Loja=%d', 'Item=%s', 'Saldo=R$ %.3f'>"
        vals = self.supsal_loja, self.supsal_item, self.supsal_saldo
        return _repr % vals