#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import VARCHAR, DECIMAL, Integer, CHAR, Enum, DateTime, ForeignKey


class CaixaMovTotalizadoresXZ(Entity):
    """
    Tabela de Totalizadores do X e do Z
    Prefixo: suptxz
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_totalizadores_xz')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    suptxz_codigo_trib_ecf = Field(CHAR(3))
    suptxz_descricao_totalizador = Field(CHAR(30))
    suptxz_valor = Field(DECIMAL(9, 3))
    suptxz_aliquota = Field(DECIMAL(4, 2))
    suptxz_base = Field(DECIMAL(5, 2))
    suptxz_tipo_imposto = Field(Enum('C', 'S', name='tipo_imposto'))
    suptxz_tipo_tributacao = Field(Enum('T', 'F', 'I', 'N', 'O', name='tipo_tribu'))
    suptxz_crz = Field(Integer(11))
    suptxz_nro_serie = Field(VARCHAR(20))
    suptxz_capa_id = Field(Integer(11), ForeignKey('caixa_mov_capa.id', onupdate="cascade",
                                                   ondelete="cascade"))
    scanntech = Field(Integer(11))

    def __repr__(self):
        _repr = "caixa_totalizadores_xz: 'IdCapa=%d', 'Valor=%.3f'>"
        vals = self.suptxz_capa_id, self.suptxz_valor
        return _repr % vals