#!/usr/bin/python
# -*- encoding: utf-8 -*-

from sigpdv.models.db_utils import a_metadata, a_session
from elixir import Entity, Field
from elixir.options import using_options
from sqlalchemy import SmallInteger, Integer, ForeignKey, DECIMAL, Date


class CaixaMovVencimentos(Entity):
    """
    Tabela de Vencimentos das finalizacoes
    Prefixo: supfve
    """
    using_options(metadata=a_metadata, session=a_session, tablename='caixa_mov_vencimentos')

    id = Field(Integer(11), primary_key=True, autoincrement=True)
    supfve_fechamentos_id = Field(Integer(11),
                                  ForeignKey('caixa_mov_fechamentos.id', onupdate='cascade'))
    supfve_sequencia_vencimento = Field(SmallInteger(6))
    supfve_valor_parcela = Field(DECIMAL(9, 2))
    supfve_vencimento = Field(Date)

    def __repr__(self):
        _repr = "<caixa_mov_vencimentos: %.3d, 'IDCapa=%d', 'Valor=R$ %.2f'>"
        vals = self.supfve_sequencia_vencimento, self.supfve_fechamentos_id, self.supfve_valor_parcela
        return _repr % vals