import os, re
from distutils.core import setup
from setuptools import find_packages
from os.path import join, dirname

packages = find_packages()

def find_package_dir():
    pkg_dir = {}
    for pkg in packages:
        for root, dirnames, filenames in os.walk(pkg):
            pkg_dir.setdefault(pkg, join(root,'')[:-1])
            break

    return pkg_dir

def find_package_data():
    pkg_data = {}

    for pkg in packages:
        for root, dirnames, filenames in os.walk(pkg):
            for filename in filenames:
                if not re.match(r'.*(\.py|\.pyc|\.pyo|\~)$', filename):
                    pkg_data.setdefault(pkg, []).append(join(root.replace(pkg+'/',''), filename))

    return pkg_data

setup(
    name='SigFrente',
    version='3.1',
    url='',
    license='',
    author='Dener Rodrigues',
    author_email='',
    description='Frente de Loja',
    packages=packages,
    package_dir=find_package_dir(),
    package_data=find_package_data(),
    include_package_data=True,    
)
