#!/usr/bin/env python
# -*- Mode: Python; coding: utf-8 -*-
__author__ = 'Dener Rodrigues'

try:
    import subprocess
    import os
    import time
    from sigpdv.tools.log_restaurante import traced as log
    sub_process = subprocess.Popen(['ps', '-ef'], stdout=subprocess.PIPE)
    out, err = sub_process.communicate()
    # caso a comanda levante duas vezes, a segunda istancia fecha automaticamente.
    for line in out.splitlines():
        dados_linha = line.split()
        if 'comanda' == dados_linha[-1] and not str(os.getpid()) in line:
                log.info('Dois Comandas abertos!')
                cmd = 'kill -9 %s' % os.getpid()
                log.info(cmd)
                os.system(cmd)

    from PyQt4 import QtCore
    import sys
    from PySide.QtCore import QSize
    from sigpdv.ui.messagebox import YES_ROLE, MSG_ERROR, MSG_QUESTION, MSG_INFO, MSG_NONE, \
        message_dlg
    from PySide import QtCore, QtGui
    from sigpdv.ui.busca_produto import BuscaProduto
    from sigpdv.ui.busca_cliente import BuscaCliente
    from sigpdv.ui.busca_obs_produto import BuscaObsProduto
    from sigpdv.ui.dlpPwd import dlg_pwd
    from sigpdv.ui.login import LoginForm
    from sigpdv.gui.ui.ui_restaurante import Ui_MainWindow
    from sigpdv.models.supervisor import SupervisorCfgParametros, SupervisorCadItens, \
        SupervisorCadVendedor, SupervisorCdaCapa, SupervisorCdaCorpo, SupervisorCdaItensFavoritos
    from sigpdv.models.db_utils import b_sess, exec_sql, testa_conexao_pg, \
        modulo_instalado_producao_comanda
    from sigpdv.models.cfg_configuracao_data import CaixaCfgConfiguracao

    from elixir import create_all, setup_all
    # setup_all  e create_all criam as tabelas que nao existem no banco de dados
    # dentro de cada arquivo do model tinha uma chamada dessas funcoes, foram retiradas pois quando o supervisor não está
    # na mesma loja ou o ip trocou, demora muito para inicializar o frente.
    try:
        setup_all()
        create_all()
    except Exception as e:
        log.error(str(e))

    from decimal import Decimal
    from sigpdv import root_path
    import traceback
    from sigpdv.control.utils import checar_conexao, get_balanca, remove_accents, \
                                     config_dados_cliente, converte_tz
    from SigUtils.decorators import TraceContext
    from datetime import datetime
    from datetime import timedelta
    from sigpdv.tools.config import config
    from stoqdrivers.exceptions import DriverError, InvalidState
    from stoqdrivers.readers.barcode.reader import BarcodeReader
    from sigpdv.ui.info_dialog import InfoDialog
    from sigpdv.tools.singleton import SingleInstance
    from sigpdv.update.update import SigFrenteUp
    from sigpdv import root_path as ROOT_PATH
    from time import sleep
    from imprimir_comanda import ImprimirComanda
    from sigpdv.__init__ import get_version
except Exception as e:
    import traceback
    import os
    from sigpdv.tools.log_restaurante import traced as log

    str_err = traceback.format_exc()
    log.error(str_err)
    try:
        app = QtGui.QApplication(sys.argv)
    except:
        pass
    message_dlg(None, MSG_ERROR, 'A Aplicação será encerrada', str_err)
    sys.exit()

TWOPLACES = Decimal(10) ** -2
TREEPLACES = Decimal(10) ** -3


@log
def exception_message_box(text, btn_quit=False):
    """
    Extract exception information and display a message box with exception details in
    a details extension of the message.
    """
    msg = QtGui.QMessageBox()
    msg.setWindowTitle(QtGui.QApplication.applicationName())
    msg.setText(text)
    # msg.setInformativeText(e)
    exc_type, exc_value, exc_traceback = sys.exc_info()
    traceback.print_exc()
    msg.setDetailedText(''.join(traceback.format_exception(exc_type, exc_value, exc_traceback)))
    msg.setStandardButtons(QtGui.QMessageBox.Ok)
    msg.setIcon(QtGui.QMessageBox.Critical)
    if btn_quit:
        msg.addButton(QtGui.QMessageBox.Close)
    ret = msg.exec_()
    if ret == QtGui.QMessageBox.Close:
        sys.exit()


K1 = ord('1') if not config['usarcodificado'] else config['bt_num_1']
K2 = ord('2') if not config['usarcodificado'] else config['bt_num_2']
K3 = ord('3') if not config['usarcodificado'] else config['bt_num_3']
K4 = ord('4') if not config['usarcodificado'] else config['bt_num_4']
K5 = ord('5') if not config['usarcodificado'] else config['bt_num_5']
K6 = ord('6') if not config['usarcodificado'] else config['bt_num_6']
K7 = ord('7') if not config['usarcodificado'] else config['bt_num_7']
K8 = ord('8') if not config['usarcodificado'] else config['bt_num_8']
K8 = ord('8') if not config['usarcodificado'] else config['bt_num_8']
K9 = ord('9') if not config['usarcodificado'] else config['bt_num_9']
K0 = ord('0') if not config['usarcodificado'] else config['bt_num_0']
KDICT = {
    K1: '1',
    K2: '2',
    K3: '3',
    K4: '4',
    K5: '5',
    K6: '6',
    K7: '7',
    K8: '8',
    K9: '9',
    K0: '0'
}


@log
def get_loja():
    res = CaixaCfgConfiguracao.get_by()
    if not res:
        config_dados = config_dados_cliente('pdvsig.sig')
        res = CaixaCfgConfiguracao.get_by()
        if not config_dados or not res or not res.supcfc_loja:
            msg = 'Empresa não cadastrada na tabela caixa_cfg_configuracao\n\n' +\
                  'A Aplicação não pode continuar'
            if not res.supcfc_loja:
                msg = "Atenção!\n\nLoja não está cadastrada no parâmetro do Supervisor!" + \
                      '\nA Aplicação não pode continuar'

            message_dlg(None, MSG_ERROR, msg)
            sys.exit()

    return res

class RestauranteForm(QtGui.QMainWindow):
    @log
    def __init__(self, operador, parent=None):

        super(RestauranteForm, self).__init__()

        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        self.QtGui = QtGui
        checar_conexao(parent=self, var=True, path='../conexao.py')
        self.estacionamento = False
        self.teclado = False
        self.btn_cancel_info_dialog = False
        self.cancel_pinpad = False
        self.loja = get_loja()

        lbl_st = self.ui.lbl_st
        sapce1 = QtGui.QLabel()
        sapce2 = QtGui.QLabel()
        # adiciona campos no statusbar
        self.ui.statusbar.addWidget(lbl_st)
        lblImgClock = self.ui.lblImgClock
        lblTime = self.ui.lblTime
        lblImgVersao = self.ui.lblImgVersao
        lblInfoVersao = self.ui.lblInfoVersao
        self.ui.verticalLayout_17.removeWidget(lblImgClock)
        self.ui.verticalLayout_17.removeWidget(lblTime)
        self.ui.verticalLayout_17.removeWidget(lblImgVersao)
        self.ui.verticalLayout_17.removeWidget(lblInfoVersao)
        self.ui.statusbar.addWidget(sapce1)
        self.ui.statusbar.addWidget(lblImgClock)
        self.ui.statusbar.addWidget(lblTime)
        self.ui.statusbar.addWidget(sapce2)
        self.ui.statusbar.addWidget(lblImgVersao)
        self.ui.statusbar.addWidget(lblInfoVersao)
        sapce1.setText('                                   ')
        sapce2.setText('                                   ')
        lblInfoVersao.setText(lblInfoVersao.text() + ' SVN-%s' % get_version())
        if not modulo_instalado_producao_comanda:
            self.ui.editMesa.setVisible(False)

        lbl_st.setText(' Operador: %s' % operador.name)

        self.ui.stackedWidget.setCurrentIndex(1)

        # SINAIS
        self.ui.spinQtda.valueChanged.connect(self._calcula_total)
        self.ui.buttonCancelaItem.pressed.connect(self._cancela_item)
        self.ui.buttonSair.pressed.connect(self._key_button_sair)
        self.ui.btn_imprimir_conferencia.pressed.connect(self.pressed_imprimir_conferencia)
        self.ui.buttonBuscaPve.pressed.connect(self.filter_pve)
        self.ui.stackedWidget.currentChanged.connect(self._update_buttons)
        self.ui.buttonCancelarPVE.pressed.connect(self._key_cancela_comanda)
        self.ui.buttonBuscarCliente.pressed.connect(self._button_busca_cliente_click)
        self.ui.edt_comanda.textChanged.connect(self.edt_comanda)
        self.ui.btnKEY_BALANCA.clicked.connect(self.KEY_BALANCA_Click)
        self.ui.btnKEY_VENDEDOR.clicked.connect(self.KEY_VENDEDOR_Click)
        self.ui.btnKEY_QUANTIDADE.clicked.connect(self.KEY_QUANTIDADE_Click)
        self.ui.tableItens.cellPressed.connect(self.cellpressed_tableItens)
        if not modulo_instalado_producao_comanda:
            self.ui.tableItens.hideColumn(7)
            self.ui.tableItens.hideColumn(8)

        # OUTROS
        self._operador = operador
        self._vendedor_id = 0
        self._nome_vendedor = ''
        self._pve = None
        self._capaPve = None
        self._cli = ''
        self._codigo_comanda = None
        self._cancelar_comanda = False
        self._CONTROL_FOCUS = None
        self._tab_order = []
        self.obs_produto = '' # obs do produto de cozinha(producao)
        self.obj_imrimir_comanda = ImprimirComanda(self)
        self._info_dialog = InfoDialog(parent=self)
        # IMAGENS
        icon = QtGui.QIcon()
        icon.addPixmap(
            QtGui.QPixmap(os.path.join(root_path, "gui/ui/images/art/scalable/apps/xfce-edit.svg")),
            QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.setWindowIcon(icon)

        icon1 = QtGui.QIcon()
        icon1.addPixmap(
            QtGui.QPixmap(os.path.join(root_path, "gui/ui/images/art/16x16/actions/gtk-open.png")),
            QtGui.QIcon.Disabled, QtGui.QIcon.Off)
        self.ui.comboStatusPve.addItem(icon1, "")

        icon2 = QtGui.QIcon()
        icon2.addPixmap(QtGui.QPixmap(os.path.join(root_path, "resources/16x16/hourglass.png")),
                        QtGui.QIcon.Normal, QtGui.QIcon.Off)
        icon2.addPixmap(QtGui.QPixmap(os.path.join(root_path, "resources/16x16/hourglass.png")),
                        QtGui.QIcon.Disabled, QtGui.QIcon.Off)
        self.ui.comboStatusPve.addItem(icon2, "")

        icon3 = QtGui.QIcon()
        icon3.addPixmap(
            QtGui.QPixmap(os.path.join(root_path, "gui/ui/images/art/16x16/actions/fileprint.png")),
            QtGui.QIcon.Disabled, QtGui.QIcon.Off)
        self.ui.comboStatusPve.addItem(icon3, "")

        icon4 = QtGui.QIcon()
        icon4.addPixmap(
            QtGui.QPixmap(os.path.join(root_path, "gui/ui/images/art/16x16/actions/kfind.png")),
            QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.ui.buttonBuscarCliente.setIcon(icon4)

        self.ui.spinQtda.setDecimals(3)
        self.ui.spinQtda.setMinimum(0)
        self.ui.spinQtda.setMaximum(9999.99)

        self.ui.spinTara.setDecimals(3)
        self.ui.spinTara.setMinimum(0)
        self.ui.spinTara.setMaximum(9999.99)

        self.status_conexao_servidor = False

        self.parametro = SupervisorCfgParametros.get_by()

        scanner_timer = QtCore.QTimer(self)
        scanner_timer.timeout.connect(self._timer)
        scanner_timer.start(3000)

        self.barcode_active = config['itens_scan_active']
        scanner_timer = QtCore.QTimer(self)
        scanner_timer.timeout.connect(self._active_scanner_timer)

        if self.barcode_active:
            try:
                self.barcode = BarcodeReader(brand='metrologic', model='MC630',
                                             device=config['scanner'])
                self.barcode._port.timeout = 0.001
            except Exception as e:
                exception_message_box(str(e), True)
                self.barcode_active = False
            scanner_timer.start(100)

        self._filtro_padrao()
        self.clear_widget_table(self.ui.tableBuscaPve)
        self.filter_pve(show_msg=False)
        self._button_nova_pve_click()

        self._atualiza_versao = False

        if config['check_atualiza']:
            self._verifica_versao()

        # KeysNumPad
        self.ui.btnKEY_0.clicked.connect(self.KEY_0_Click)
        self.ui.btnKEY_1.clicked.connect(self.KEY_1_Click)
        self.ui.btnKEY_2.clicked.connect(self.KEY_2_Click)
        self.ui.btnKEY_3.clicked.connect(self.KEY_3_Click)
        self.ui.btnKEY_4.clicked.connect(self.KEY_4_Click)
        self.ui.btnKEY_5.clicked.connect(self.KEY_5_Click)
        self.ui.btnKEY_6.clicked.connect(self.KEY_6_Click)
        self.ui.btnKEY_7.clicked.connect(self.KEY_7_Click)
        self.ui.btnKEY_8.clicked.connect(self.KEY_8_Click)
        self.ui.btnKEY_9.clicked.connect(self.KEY_9_Click)
        self.ui.btnKEY_COMMA.clicked.connect(self.KEY_COMMA_Click)
        self.ui.btnKEY_BACKSPACE.clicked.connect(self.KEY_BACKSPACE_Click)
        # KeysFavoritos
        self.ui.frmKeysDirection_favoritos.setVisible(False)
        self.ui.btnFavorito1.clicked.connect(self._seleciona_favorito1)
        self.ui.btnFavorito2.clicked.connect(self._seleciona_favorito2)
        self.ui.btnFavorito3.clicked.connect(self._seleciona_favorito3)
        self.ui.btnFavorito4.clicked.connect(self._seleciona_favorito4)
        self.ui.btnFavorito5.clicked.connect(self._seleciona_favorito5)
        self.ui.btnFavorito6.clicked.connect(self._seleciona_favorito6)
        ## KeysActions
        self.ui.btnKEY_RETURN.clicked.connect(self.KEY_RETURN_Click)
        self.ui.btnKEY_LEFT.clicked.connect(self.KEY_LEFT_Click)
        self.ui.btnKEY_UP.clicked.connect(self.KEY_UP_Click)
        self.ui.btnKEY_RIGHT.clicked.connect(self.KEY_RIGHT_Click)
        self.ui.btnKEY_DOWN.clicked.connect(self.KEY_DOWN_Click)
        # TIMER PRINCIPAL
        self._timer_principal()
        timer_principal = QtCore.QTimer(self)
        timer_principal.timeout.connect(self._timer_principal)
        timer_principal.start(1000)
        for ext in ['.png', '.jpg', '.jpeg', '.gif']:
            image = '%s/logo%s' % (config['local'], ext)
            image_exist = os.path.exists(image)
            if image_exist:
                self.ui.lblImage.setPixmap(QtGui.QPixmap(image))
                break

    def _verifica_versao(self):
        self.show_info_proccess(True, 'Verificando atualizações disponíveis!')
        self.ui.stackedWidget.setCurrentIndex(2)
        self.setControlFocus(self._CONTROL_FOCUS, self.ui.text_log)
        if not SigFrenteUp(self, frente_comanda='C').do_checks_version():
            if self._atualiza_versao == True:
                message_dlg(None, MSG_ERROR, 'Falha ao atualizar o sistema!')
            self.ui.stackedWidget.setCurrentIndex(1)
            self.setControlFocus(self._CONTROL_FOCUS, self.ui.edt_comanda)
        else:
            if self._atualiza_versao == True:
                inc = 0
                loop = 10
                while True:
                    inc += 1
                    self.show_info_proccess(True, 'Atualização concluída! \n'
                                                  'Aguarde, o sistema irá reiniciar '
                                                  'em (%d-%d)' % (inc, loop))
                    QtGui.QApplication.processEvents()
                    sleep(1)
                    if inc == loop:
                        try:
                            cmd = 'chmod +x %s' % __file__
                            os.system(cmd)
                            log.info(cmd)
                            pid = str(os.getpid())
                            log.info('PID: %s' % pid)
                            dir = '%s/comanda' % ROOT_PATH
                            os.execl(dir, pid)
                        except Exception as err:
                            msg = 'Erro ao Recarregar o Sistema! \n\n%s' % str(err)
                            message_dlg(None, MSG_ERROR, msg)
                            log.error(msg)
                        break
        self.show_info_proccess(False)
        return True

    def _timer_principal(self):
        self.ui.lblTime.setText(datetime.now().strftime('%d/%m/%Y %H:%M'))

    @log
    def setControlFocus(self, old, new, is_escape=False):
        old_name, new_name = ('', '')
        if old:
            old_name = old.objectName()
        if new:
            new_name = new.objectName()
        if not is_escape:
            self._tab_order.append(new)
        if old:
            old.setStyleSheet("")

        self._CONTROL_FOCUS = new

        if type(new) in [QtGui.QLineEdit, QtGui.QDoubleSpinBox, QtGui.QComboBox, QtGui.QDateEdit]:
            new.setStyleSheet("background-color: rgba(153, 204, 204, 255); color: rgb(0, 0, 127)")

            if type(old) in [QtGui.QDoubleSpinBox, QtGui.QDateEdit]:
                ev = QtGui.QKeyEvent(QtCore.QEvent.KeyPress, QtCore.Qt.Key_Up,
                                     QtCore.Qt.KeyboardModifiers())
                old.keyPressEvent(ev)
                ev = QtGui.QKeyEvent(QtCore.QEvent.KeyPress, QtCore.Qt.Key_Down,
                                     QtCore.Qt.KeyboardModifiers())
                old.keyPressEvent(ev)
                ev = QtGui.QKeyEvent(QtCore.QEvent.KeyPress, QtCore.Qt.Key_End,
                                     QtCore.Qt.KeyboardModifiers())
                old.keyPressEvent(ev)

            elif type(new) in [QtGui.QDoubleSpinBox, QtGui.QDateEdit]:
                ev = QtGui.QKeyEvent(QtCore.QEvent.KeyPress, QtCore.Qt.Key_Up,
                                     QtCore.Qt.KeyboardModifiers())
                new.keyPressEvent(ev)
                ev = QtGui.QKeyEvent(QtCore.QEvent.KeyPress, QtCore.Qt.Key_Down,
                                     QtCore.Qt.KeyboardModifiers())
                new.keyPressEvent(ev)
        elif type(new) == QtGui.QTableWidget:
            new.setStyleSheet('background-color: rgb(255, 252, 205)')

        if self._CONTROL_FOCUS.objectName() != 'editCodItem':
            self.ui.label_edit_1.setText(u'Cód. do Produto:')

        try:
            new.selectAll()
            new.setFocus()
        except Exception as e:
            pass

        return True

    @log
    def _on_key_click(self, key):
        self._tempo_ocioso = 0
        text = chr(key) if key < 256 else ''
        text = text if text != '-' else ''
        ev = QtGui.QKeyEvent(QtCore.QEvent.KeyPress, key, QtCore.Qt.KeyboardModifiers(), text=text)
        obj_name = str(self._CONTROL_FOCUS.objectName()).lower()
        if type(self._CONTROL_FOCUS) in [QtGui.QLineEdit, QtGui.QDoubleSpinBox, QtGui.QDateEdit,
                                         QtGui.QComboBox] and key == QtCore.Qt.Key_Return:
            if self._CONTROL_FOCUS == self.ui.edt_comanda:
                return self._button_filtro_cod_pve_click()
            try:
                return eval('self.%s()' % obj_name)
            except Exception as err:

                self.keyPressEvent(ev)

        # BACKSPACE
        if type(self._CONTROL_FOCUS) in [QtGui.QLineEdit, QtGui.QDoubleSpinBox, QtGui.QDateEdit] and \
                        key == QtCore.Qt.Key_Backspace.__int__():
            self._CONTROL_FOCUS.selectAll()
            self._CONTROL_FOCUS.clear()
            self._CONTROL_FOCUS.selectAll()
        if type(self._CONTROL_FOCUS) in [QtGui.QLineEdit, QtGui.QDoubleSpinBox, QtGui.QDateEdit] and \
                        key == QtCore.Qt.Key_Down.__int__():
            return

        self._CONTROL_FOCUS.keyPressEvent(ev)
        if type(self._CONTROL_FOCUS) == QtGui.QListWidget:
            self._CONTROL_FOCUS.clearFocus()

    def KEY_0_Click(self):
        return self._on_key_click(QtCore.Qt.Key_0)

    def KEY_1_Click(self):
        return self._on_key_click(QtCore.Qt.Key_1)

    def KEY_2_Click(self):
        return self._on_key_click(QtCore.Qt.Key_2)

    def KEY_3_Click(self):
        return self._on_key_click(QtCore.Qt.Key_3)

    def KEY_4_Click(self):
        return self._on_key_click(QtCore.Qt.Key_4)

    def KEY_5_Click(self):
        return self._on_key_click(QtCore.Qt.Key_5)

    def KEY_6_Click(self):
        return self._on_key_click(QtCore.Qt.Key_6)

    def KEY_7_Click(self):
        return self._on_key_click(QtCore.Qt.Key_7)

    def KEY_8_Click(self):
        return self._on_key_click(QtCore.Qt.Key_8)

    def KEY_9_Click(self):
        return self._on_key_click(QtCore.Qt.Key_9)

    def KEY_COMMA_Click(self):
        return self._on_key_click(QtCore.Qt.Key_Comma)

    def KEY_BACKSPACE_Click(self):
        return self._on_key_click(QtCore.Qt.Key_Backspace)

    def KEY_RETURN_Click(self):
        return self._on_key_click(QtCore.Qt.Key_Return)

    def KEY_LEFT_Click(self):
        return self._on_key_click(QtCore.Qt.Key_Left)

    def KEY_UP_Click(self):
        tab_order = self._tab_order
        if len(tab_order) > 1:
            if type(self._CONTROL_FOCUS) in [QtGui.QComboBox, QtGui.QTableWidget]:
                index = self._CONTROL_FOCUS.currentIndex()
                if index > 0:
                    return self._on_key_click(QtCore.Qt.Key_Up)
                elif index == 0 and type(self._CONTROL_FOCUS) == QtGui.QTableWidget:
                    tab_order.remove(self._CONTROL_FOCUS)
                    return self.setControlFocus(self._CONTROL_FOCUS, tab_order[-1], True)
            tab_order.remove(self._CONTROL_FOCUS)
            self.setControlFocus(self._CONTROL_FOCUS, tab_order[-1], True)
        else:
            if type(self._CONTROL_FOCUS) in [QtGui.QComboBox, QtGui.QTableWidget]:
                index = self._CONTROL_FOCUS.currentIndex()
                if index > 0:
                    return self._on_key_click(QtCore.Qt.Key_Up)
                elif index == 0 and type(self._CONTROL_FOCUS) == QtGui.QTableWidget:
                    return self._on_key_click(QtCore.Qt.Key_Up)
            self.setControlFocus(self._CONTROL_FOCUS, tab_order[-1], True)
        return

    def KEY_RIGHT_Click(self):
        return self._on_key_click(QtCore.Qt.Key_Right)

    def KEY_DOWN_Click(self):
        return self._on_key_click(QtCore.Qt.Key_Down)

    @log
    def _key_cancela_comanda(self):
        if not self._cancelar_comanda:
            self._cancelar_comanda = True
            self._button_nova_pve_click()
            self.ui.buttonCancelarPVE.setStyleSheet(
                "border-image: url(:/buttons/images/buttons/blue_pressed.png);")
        else:
            self._cancelar_comanda = False
            self._button_nova_pve_click()
            self.ui.buttonCancelarPVE.setStyleSheet(
                "border-image: url(:/buttons/images/buttons/normal.png);")

    @log
    def KEY_BALANCA_Click(self):
        """ Tecla alterar quantidade do item """
        self.ui.btnKEY_BALANCA.setEnabled(False)
        if config['balanca_active']:
            self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
            self._CONTROL_FOCUS.clear()
            self.ui.labelItem.setText(u'Obtendo o Peso da Balança')
            # ITEM DE BALANÇA
            self.ui.spinQtda.setDecimals(3)
            try:
                self.ui.spinQtda.setValue(self._obter_peso_balanca())
                self.ui.labelItem.setText('Digite o Código do Produto Pesável.')
            except DriverError as e:
                self.ui.btnKEY_BALANCA.setEnabled(True)
                self.ui.spinQtda.setDecimals(0)
                self.ui.spinQtda.setValue(1)
                self.show_info_proccess(False)
                message_dlg(self, MSG_INFO, 'Balança desconectada')
                return False
            except InvalidState:
                self.ui.btnKEY_BALANCA.setEnabled(True)
                self.ui.spinQtda.setDecimals(0)
                self.ui.spinQtda.setValue(1)
                message_dlg(self, MSG_INFO, 'Não foi possível obter o peso da balança.')
                return False
            except AssertionError:
                self.show_info_proccess(False)
                pass
            self.ui.btnKEY_BALANCA.setEnabled(True)
            return True
        else:
            self.ui.btnKEY_BALANCA.setEnabled(True)
            message_dlg(self, MSG_INFO, 'O sistema não está configurado p/ usar balança!\n\n',
                                        'Contacte o Administrador do Sistema.')
            return False

    @log
    def _obter_peso_balanca(self, p_timeout=5):
        inc = 0
        self.show_info_proccess(True, 'Conectando com a balança')
        QtGui.QApplication.processEvents()
        while inc != p_timeout:
            try:
                self._balanca = get_balanca(show_dialog=False)
                ret = self._balanca.read_data()
                if ret <= 0:
                    raise Exception('Não foi possivel obter o peso da Balança')
                self.show_info_proccess(False, '')
                return ret
            except DriverError as e:
                raise DriverError('Erro ao conectar com a Balança')

            except AssertionError:
                self.show_info_proccess(False)
                raise AssertionError()
            except Exception as e:
                log.error(str(e))
                self.show_info_proccess(True, 'Checando a balança: %d/%d' % (inc + 1, p_timeout))
                QtGui.QApplication.processEvents()
                inc += 1
                continue

        if inc == p_timeout:
            self.show_info_proccess(False)
            raise InvalidState('Não foi possível obter o peso da Balança')

    @log
    def show_info_proccess(self, visible, msg="Processo demorado", tef=False, close=False):
        # CENTRALIZAR
        self._info_dialog._not_close = visible
        if close:
            self._info_dialog._not_close = False

        if tef and self._info_dialog.isVisible():
            self._info_dialog.set_info_text(self.trUtf8(msg))
            return self._info_dialog._done

        if visible:
            self._info_dialog.set_info_text(self.trUtf8(msg))
            if self._info_dialog.isVisible():
                return self._info_dialog._done
            self._info_dialog.showNormal()
            QtGui.QApplication.processEvents()
        else:
            self._info_dialog.close()
        ret = self._info_dialog._done
        self._info_dialog._done = False
        return ret

    @log
    def edt_comanda(self, value):
        self.ui.editBuscaPve.setEnabled(True)
        self.ui.frmPeriodo.setEnabled(True)
        self.ui.comboFiltroStatus.setEnabled(True)

        if value:
            log.info('Código comanda: %s' % str(value))
            try:
                if int(value) <= int(config['limite_comanda']):
                    self.ui.editBuscaPve.setEnabled(False)
                    self.ui.frmPeriodo.setEnabled(False)
                    self.ui.comboFiltroStatus.setEnabled(False)
                else:
                    self.ui.edt_comanda.clear()
                    message_dlg(None, MSG_ERROR,
                                'O código da comanda deve ser menor que %s '
                                '\n\n Código informado: %s ' % (config['limite_comanda'],
                                                                str(value)))
            except Exception as err:
                self.ui.edt_comanda.clear()
                log.error(str(err.message))
                message_dlg(None, MSG_ERROR, 'O código da comanda deve ser numérico! \n\n'
                                             'Código informado: %s' % str(value))

    @log
    def populate_tablepve(self, pves):
        table_pve = self.ui.tableBuscaPve
        self.clear_widget_table(table_pve)

        row = 0
        for pve in pves:
            table_pve.insertRow(row)
            # Status
            icon3 = QtGui.QIcon()
            if pve.supcda_restricao == -1:
                rest = 'Cancelado'
                icon3.addPixmap(
                    QtGui.QPixmap(
                        os.path.join(root_path, "gui/ui/images/art/16x16/actions/gtk-cancel.png")),
                    QtGui.QIcon.Disabled, QtGui.QIcon.Off)
            elif pve.supcda_restricao == 0:
                rest = 'Aberto'
                icon3.addPixmap(QtGui.QPixmap(
                    os.path.join(root_path, "gui/ui/images/art/16x16/actions/gtk-open.png")),
                                QtGui.QIcon.Disabled, QtGui.QIcon.Off)
            elif pve.supcda_restricao == 1:
                rest = u'Aguardando Emissão'
                icon3.addPixmap(
                    QtGui.QPixmap(os.path.join(root_path, "resources/16x16/hourglass.png")),
                    QtGui.QIcon.Disabled, QtGui.QIcon.Off)
            elif pve.supcda_restricao == 4:
                rest = u'Anulada'
                icon3.addPixmap(
                    QtGui.QPixmap(
                        os.path.join(root_path, "gui/ui/images/art/16x16/actions/gtk-cancel.png")),
                    QtGui.QIcon.Normal, QtGui.Disabled.Off)
            elif pve.supcda_restricao == 5:
                rest = u'Faturando'
                icon3.addPixmap(
                    QtGui.QPixmap(os.path.join(root_path, "resources/16x16/hourglass.png")),
                    QtGui.QIcon.Disabled, QtGui.QIcon.Off)
            else:
                rest = 'Fechado'
                icon3.addPixmap(QtGui.QPixmap(
                    os.path.join(root_path, "gui/ui/images/art/16x16/actions/fileprint.png")),
                                QtGui.QIcon.Disabled, QtGui.QIcon.Off)

            item_check = QtGui.QTableWidgetItem(rest)
            item_check.setIcon(icon3)
            # Codigo
            item_cod = QtGui.QTableWidgetItem('%010d' % pve.supcda_codigo_comanda)
            # Nro Cupom
            ncupom = 0 if not pve.supcda_nro_cupom else pve.supcda_nro_cupom
            nro_cupom = QtGui.QTableWidgetItem('%06d' % ncupom)
            # data
            item_data = QtGui.QTableWidgetItem(
                '%s' % pve.supcda_data_hora.strftime('%d/%m/%Y %H:%M'))
            # CPF
            item_cpf = QtGui.QTableWidgetItem(pve.supcda_cliente)
            # Nome Cliente
            item_nome = QtGui.QTableWidgetItem(pve.supcda_nome_cliente)
            # Valor
            supcda_total_comanda = pve.supcda_total_comanda if pve.supcda_total_comanda else 0
            item_vr = QtGui.QTableWidgetItem('%1.2f' % supcda_total_comanda)
            item_vr.setTextAlignment(QtCore.Qt.AlignRight | QtCore.Qt.AlignVCenter)

            # WidGET OS NEW ITENS NA TABLE ITENS
            table_pve.setItem(row, 0, item_check)
            table_pve.setItem(row, 1, nro_cupom)
            table_pve.setItem(row, 2, item_cod)
            table_pve.setItem(row, 3, item_data)
            table_pve.setItem(row, 4, item_cpf)
            table_pve.setItem(row, 5, item_nome)
            table_pve.setItem(row, 6, item_vr)
            row += 1
            table_pve.resizeColumnsToContents()
            table_pve.horizontalHeader().setStretchLastSection(True)

    @log
    def filter_pve(self, show_msg=True):
        """
        Filtra a lista de pre vendas:
        """

        res_query = []
        str_filtro = 'O Filtro: '
        cod_pve = cd = 0

        try:
            cd = self.ui.edt_comanda.text()
            cod_pve = int(cd)
            log.info('Código comanda: %s' % str(cd))
            if not int(cd) <= int(config['limite_comanda']):
                self.ui.edt_comanda.clear()
                self.setControlFocus(self._CONTROL_FOCUS, self.ui.edt_comanda)
                return message_dlg(None, MSG_ERROR,
                                   'O código da comanda deve ser menor que %s '
                                   '\n\n Código informado: %s ' % (config['limite_comanda'],
                                                                   str(cd)))
        except ValueError:
            if not self.ui.edt_comanda.text() is u'':
                self.ui.edt_comanda.clear()
                self.setControlFocus(self._CONTROL_FOCUS, self.ui.edt_comanda)
                return message_dlg(None, MSG_ERROR,
                                   'O código da comanda deve ser numérico! \n\n'
                                   'Código informado: %s' % str(cd))

        if cod_pve:  # BUSCAR POR id
            res_query = SupervisorCdaCapa.query.join(capa).filter(SupervisorCdaCapa.id == cod_pve).all()
            str_filtro = u"Por Codigo da Comanda = '%s'" % self.ui.edt_comanda.text()
        else:  # BUSCAR POR PERÍODO
            status_pve = 0
            curr = self.ui.comboFiltroStatus.currentIndex()
            if curr == 1:
                status_pve = -1  # Cancelada
            elif curr == 2:
                status_pve = 2  # Aguardando emissao

            data_ini = self.ui.dateIni.dateTime().toPython()
            data_fim = self.ui.dateFim.dateTime().toPython()
            str_filtro = u"No Período de '%s' a '%s'" % (
                self.ui.dateIni.text(), self.ui.dateFim.text())
            data_atual = datetime.today().date()
            # Validar os valores dos controles DateTime
            msg = ''
            if data_ini.date() > data_atual:
                msg = "A 'Data Inicial: %s' não pode ser maior que a 'Data Atual: %s'" % (
                    data_ini.date(), data_atual)
                self.ui.dateIni.selectAll()
                self.ui.dateIni.setFocus()
            elif data_ini.date() > data_fim.date():
                msg = "A 'Data Inicial: %s' não pode ser maior que a 'Data Final: %s'" % (
                    data_ini.date(), data_fim)
                self.ui.dateIni.selectAll()
                self.ui.dateIni.setFocus()
            if data_fim.date() > data_atual:
                msg = "A 'Data Final: %s' não pode ser maior que a 'Data Atual: %s" % (
                    data_fim.date(), data_atual)
                self.ui.dateFim.selectAll()
                self.ui.dateFim.setFocus()

            if msg:
                return message_dlg(self, MSG_INFO, msg)
            else:
                nome_cpf_cliente = self.ui.editBuscaPve.text()
                if nome_cpf_cliente:
                    if nome_cpf_cliente.isdigit():
                        str_filtro += u" e CPF = %r" % nome_cpf_cliente
                        res_query = SupervisorCdaCapa.query.filter(
                            SupervisorCdaCapa.supcda_data_hora.between(data_ini, data_fim)).filter(
                            SupervisorCdaCapa.supcda_cliente == nome_cpf_cliente
                        ).filter(SupervisorCdaCapa.supcda_restricao == status_pve).all()
                    else:
                        str_filtro += u" e Nome do Cliente contêm '%s'" % nome_cpf_cliente
                        p_like = SupervisorCdaCapa.supcda_nome_cliente.like('%s%s%s' %
                                                                       ('%', nome_cpf_cliente, '%'))
                        res_query = SupervisorCdaCapa.query.filter(
                            SupervisorCdaCapa.supcda_data_hora.between(data_ini, data_fim)).filter(
                            p_like
                        ).filter(SupervisorCdaCapa.supcda_restricao == status_pve).all()
                else:
                    res_query = SupervisorCdaCapa.query.filter(
                        SupervisorCdaCapa.supcda_data_hora.between(data_ini, data_fim)).filter(
                        SupervisorCdaCapa.supcda_restricao == status_pve).all()
        str_filtro += u" Restrição = '%s' " % self.ui.comboFiltroStatus.currentText()
        str_filtro += u". Retornou %d Registro(s)." % len(res_query)
        self.ui.lblResFiltro.setText(str_filtro)

        if not res_query and show_msg and not self._cancelar_comanda:
            self.clear_widget_table(self.ui.tableBuscaPve)

            return message_dlg(self, MSG_INFO, 'A busca não retornou resultados')
        self.populate_tablepve(res_query)
        self.ui.tableBuscaPve.setFocus()
        self.ui.tableBuscaPve.selectRow(0)
        return res_query

    @log
    def _filtro_padrao(self):
        date_ini = datetime.today()
        y, m, d = date_ini.year, date_ini.month, date_ini.day
        self.ui.dateIni.setDate(QtCore.QDate(y, m, d))
        date_fim = datetime.today()
        y, m, d = date_fim.year, date_fim.month, date_fim.day
        self.ui.dateFim.setDate(QtCore.QDate(y, m, d))

        self.ui.editBuscaPve.clear()
        self.ui.comboFiltroStatus.setCurrentIndex(2)

    def _timer(self):
        st = self.status_conexao_servidor
        self.ui.radioButton.setChecked(st)
        try:
            if not st:
                time.sleep(1)
                file = open('/tmp/conexao_frente.txt', 'r')
                res = file.read()
                file.close()
                if res == '1':
                    self.status_conexao_servidor = True
                    st = True
                    self.ui.radioButton.setChecked(st)
                if not st:
                    raise Exception('Sem conexao com o Banco de Dados Supervisor.')

        except Exception as e:
            exception_message_box(str(e), True)
        return st

    @log
    def _active_scanner_timer(self):
        cod = ''
        try:
            if QtGui.QApplication.activeWindow():
                cod = self.barcode.get_code()
        except Exception as e:
            cod = ''
        if self._CONTROL_FOCUS in [self.ui.editCodItem, BuscaCliente]:
            if cod:
                old_focul = self._CONTROL_FOCUS
                self._CONTROL_FOCUS.setText(cod)
                QtGui.QApplication.processEvents()
                self.KEY_RETURN_Click()
                if old_focul == BuscaCliente and config.get('usarcodificado', False):
                    self.setControlFocus(self._CONTROL_FOCUS, BuscaCliente)

    @log
    def exception_message_box(self, text):
        return exception_message_box(text)

    @log
    def _update_buttons(self, *args):
        icon = QtGui.QIcon()
        idx = self.ui.stackedWidget.currentIndex()
        if idx == 0:
            self.ui.btnKEY_BALANCA.setEnabled(True)  # habilitar botao da balanca
            self.ui.btnKEY_QUANTIDADE.setEnabled(True)
            icon.addPixmap(QtGui.QPixmap(
                os.path.join(root_path, "gui/ui/images/art/24x24/actions/edit-redo.png")),
                           QtGui.QIcon.Normal, QtGui.QIcon.Off)
            caption = 'Voltar'
            self.ui.buttonSair.setText(caption)
            self.ui.buttonSair.setShortcut('Esc')
        else:
            self.ui.btnKEY_BALANCA.setEnabled(False)  # Desabilitar botao de balanca
            self.ui.btnKEY_QUANTIDADE.setEnabled(False)
            icon.addPixmap(QtGui.QPixmap(os.path.join(root_path,
                                                      "gui/ui/images/art/24x24/apps/accessories-text-editor.png")),
                           QtGui.QIcon.Normal, QtGui.QIcon.Off)
            caption = 'Sair'
            self.ui.buttonSair.setText(caption)
        self.ui.buttonCancelarPVE.setVisible(bool(idx))
        self.setControlFocus(self._CONTROL_FOCUS, self.ui.edt_comanda)
        self._capaPve = None

    @log
    def _key_button_sair(self):
        if self.ui.buttonSair.text() == 'Sair':
            if message_dlg(self, MSG_QUESTION, 'Deseja encerrar a aplicação?') == YES_ROLE:
                self.close()
                os.system('killall -9 python')
        else:
            self.ui.editMesa.setText('')
            self.ui.stackedWidget.setCurrentIndex(1)
            self.ui.frmKeysDirection_favoritos.setVisible(False)
            self.ui.edt_comanda.clear()
            if modulo_instalado_producao_comanda:
                corpos = SupervisorCdaCorpo.query.filter(
                    SupervisorCdaCorpo.supcdo_capa_id == self._pve.id).\
                    filter(SupervisorCdaCorpo.supcdo_imprimir=='2').order_by('supcdo_sequencia_id')
                if corpos.all():
                    b_sess.begin()
                    for corpo in corpos:
                        corpo.supcdo_imprimir = '3'

                    b_sess.commit()
                    self.obj_imrimir_comanda.imprimir_pedidos_cozinha()

    @log
    def pressed_imprimir_conferencia(self):
        if not self._pve:
            return 'Comanda não encontrada'

        ini_negrito = '%s%s' % (chr(27), chr(69))
        fim_negrito = '%s%s' % (chr(27), chr(70))
        percentual = 0
        if self.parametro:
            percentual = self.parametro.supcfp_comissao

        dados_comanda = exec_sql('SELECT * FROM supervisor_cda_capa WHERE id = %s' % self._pve.id, 'S')[0]
        nro_comanda = dados_comanda.get('supcda_codigo_comanda')
        data = converte_tz(self, dados_comanda.get('supcda_data_hora'), 'UTC', 'America/Sao_Paulo').strftime('%d/%m/%Y %H:%M:%S')
        situacao = {-1: 'Cancelada',
                     0: 'Aberta',
                     1: 'Aguardando emissao no frente(Iniciou faturamento',
                     2: 'Faturada',
                    }.get(dados_comanda.get('supcda_restricao'))

        text = ['%s%s%s' % (ini_negrito, self.loja.supcfc_cliente[:48].center(48), fim_negrito),
                ('DATA IMPRESSAO: %s' % datetime.now().strftime('%d/%m/%Y %H:%M:%S')).rjust(48),
                '',
                '-----------* CONFERENCIA DE COMANDA *-----------',
                '',
                'NRO. COMANDA: %s%06d%s' % (ini_negrito, nro_comanda, fim_negrito),
                'MESA: %s%03d%s' % (ini_negrito, dados_comanda.get('supcda_mesa') or 0, fim_negrito),
                'DATA: %s' % data,
                'SITUACAO: %s' % situacao,
                '',
                'PRODUTO',
                ' QTD.                    VR.UNIT.        VALOR: ',
                '------------------------------------------------']
        itens = exec_sql('''
                SELECT sci.supite_descricao_completa AS descricao,
                       scc.supcdo_preco_total        AS preco,
                       scc.supcdo_quantidade         AS qtd,
                       scc.supcdo_venda_cancelamento AS venda_cancelamento
                FROM supervisor_cda_corpo       AS scc 
                INNER JOIN supervisor_cad_itens AS sci ON sci.supite_codigo_item = scc.supcdo_item
                WHERE scc.supcdo_capa_id = %s
                ORDER BY scc.supcdo_sequencia_id''' % self._pve.id, 'S')
        for i in itens:
            if i.get('venda_cancelamento') == 'C':
                continue

            qtd = str(i.get('qtd')).rjust(3)
            vr_unit = ('%0.2f' % (i.get('preco')/i.get('qtd'))).rjust(6)
            preco = ('%0.2f' % i.get('preco')).rjust(7)
            text.extend([i.get('descricao'),
                         ' %sx                 R$ %s    R$ %s ' % (qtd, vr_unit, preco)])

        subtotal = str(Decimal(dados_comanda.get('supcda_total_comanda')).quantize(TWOPLACES)).rjust(9)
        text.extend(['',
                     '------------------------------------------------',
                     '                         %sSUBTOTAL  R$ %s%s' %
                                                              (ini_negrito, subtotal, fim_negrito)])
        vr_percentual = 0
        if percentual:
            vr_percentual = Decimal(dados_comanda.get('supcda_total_comanda') * percentual / 100
                                    ).quantize(TWOPLACES)
            str_percent = ('%.2f' % vr_percentual).rjust(9)
            text.extend([
                     '                         %s+ %s%%  R$ %s%s' %
                                                (ini_negrito, percentual, str_percent, fim_negrito)

            ])
        else:
            text.extend([''])

        total = ('%.2f' % (Decimal(dados_comanda.get('supcda_total_comanda')).quantize(TWOPLACES) +
                           vr_percentual)).rjust(9)
        text.extend(['                         -----------------------',
                     '                            %s\x1b-\x01TOTAL  R$ %s\x1b-\x00%s' %
                     (ini_negrito, total, fim_negrito),
                     '',
                     'DESENVOLVIDO POR:',
                     '%sSig Solucoes em Informatica Ltda. (31)2106-1700%s' % (ini_negrito,
                                                                              fim_negrito),
                     '%s%s' % (chr(27), chr(109)), # corta papel
                     ])

        data = dados_comanda.get('supcda_data_hora').strftime('%d-%m-%Y_%H:%M:%S')
        path = '/tmp/conferencia_comanda_%s_%s.txt' % (nro_comanda, data)
        impressora = config['impressora_conferencia']
        if not impressora:
            return message_dlg(self, MSG_INFO, 'Atenção!\n\nImpressora não cadastrada no '
                                               'PDVConfig!')

        file = open(path, 'w')
        file.write('\n'.join(text))
        file.close()
        try:
            subprocess.call(["lp", "-n1", '-d%s' % impressora, path])
        except Exception as e:
            log.error('Erro ao imprimir conferencia de comanda: %s' % e, tipo='E')
            message_dlg(self, MSG_INFO, 'Atenção!\n\nErro ao imprimir conferência.'
                                        ' Contate o Supervisor!')

        return True

    @log
    def _alternar(self, *args):
        if Decimal(str(self.ui.spinTotalPve.text().replace(',', '.'))) > 0:
            rest = 1
            if not SupervisorCdaCorpo.get_by(supcdo_capa_id=self._pve.id, supcdo_venda_cancelamento='V'):
                rest = 0
            b_sess.begin()
            if self._cli and not self._pve.supcda_cliente:
                self._pve.supcda_cliente = self._cli.supcli_cnpj_cpf
                self._pve.supcda_nome_cliente = self._cli.name

            self._pve.supcda_restricao = rest
            b_sess.commit()
            self.ui.stackedWidget.setCurrentIndex(1)
            self._filtro_padrao()
            self.populate_tablepve([self._pve])
            self.ui.labelItem.clear()
            self._cli = ''
        else:
            message_dlg(self, MSG_INFO, 'Comanda',
                        u'Não posso concluir Comanda\nInsira no minimo um item.')

    @log
    def _clear_widgets(self):
        self.clear_widget_table(self.ui.tableItens)
        self.ui.editNumPve.clear()
        self.ui.dateEmissaoPve.clear()
        self.ui.comboStatusPve.setCurrentIndex(0)
        self.ui.editDocCliente.clear()
        self.ui.spinTotalPve.setValue(0)
        self.ui.editCodItem.clear()
        self.ui.spinQtda.setValue(1)
        self.ui.spinTotalPve.setValue(0)
        self.ui.spinVlItem.setValue(0)
        self.ui.spinVlTotal.setValue(0)
        self._vendedor_id = 0
        self._nome_vendedor = None

    @log
    def _cancelar_pve(self, comanda):
        pve = comanda[0]
        id_cmda = pve.supcda_codigo_comanda
        st = pve.supcda_restricao
        id = pve.id
        idx = self.ui.tableBuscaPve.currentIndex()

        if st in [0, 1] and not pve.supcda_nro_cupom:
            if self._operador.supope_operador_supervisor == 'S' or self._operador.supope_cancela_item:
                cancela = True
            else:
                dlg = dlg_pwd(self, msg_info='Cancelamento da comanda %010d' % id_cmda)
                if dlg.exec_():
                    cancela = True
                else:
                    cancela = False
                    message_dlg(self, MSG_INFO, 'Operador não tem permissão para cancelar comanda')
            if cancela is True:
                if message_dlg(self, MSG_QUESTION,
                               'Cancelar comanda\n\n'
                               'Deseja cancelar a comanda: %010d' % id_cmda) == YES_ROLE:
                    pve = SupervisorCdaCapa.get_by(id=id)
                    b_sess.begin()
                    pve.supcda_restricao = -1
                    b_sess.commit()
                    self.ui.edt_comanda.clear()
                    self.filter_pve()
                    self.ui.tableBuscaPve.setCurrentIndex(idx)

        elif st == 4:
            message_dlg(self, MSG_INFO, 'Comanda No. %010d Foi anulada.' % id_cmda)
        elif st == 5:
            message_dlg(self, MSG_INFO, 'No. %010d está sendo processada '
                                        'pelo frente.' % id_cmda)
        elif st == -1:
            message_dlg(self, MSG_INFO, 'Comanda No. %010d Já está cancelada.' % id_cmda)
        self.ui.edt_comanda.clear()
        self._button_nova_pve_click()
        self._cancelar_comanda = False

    @log
    def _editar_pve(self, *args):
        if self.ui.stackedWidget.currentIndex() == 1:
            if self.ui.tableBuscaPve.selectedItems():
                id_pve = self.ui.tableBuscaPve.item(self.ui.tableBuscaPve.currentRow(), 2).text()
                status = self.ui.tableBuscaPve.item(self.ui.tableBuscaPve.currentRow(), 0).text()
                id_pve = int(id_pve)

                self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
                pve = SupervisorCdaCapa.get_by(id=id_pve)
                if not pve:
                    return message_dlg(self, MSG_INFO, 'Comanda não encontrada')

                rest = pve.supcda_restricao
                if pve.supcda_nro_cupom:
                    if message_dlg(self, MSG_QUESTION, 'Comanda',
                                   'Não é possivel alterar a comanda selecionada.\n'
                                   '* Cupom: %06d já foi emitido.\n\nDeseja visualizar?' %
                                           pve.supcda_nro_cupom) == YES_ROLE:
                        self.editar_pve(id_pve, ro=False)
                elif rest == 5:
                    if message_dlg(self, MSG_QUESTION, 'Comanda',
                                   'Não é possivel alterar a Pré-Venda selecionada.'
                                   '\n\nDeseja visualizar?') == YES_ROLE:
                        self.editar_pve(id_pve, ro=False)
                        # self.buscar_pve()
                elif rest in [0, 1]:
                    self.editar_pve(id_pve)
                elif rest == -1:
                    self.editar_pve(id_pve, ro=False)
                else:
                    message_dlg(self, MSG_INFO, 'Comanda',
                                'Não posso alterar comanda: %s' % status)
            else:
                message_dlg(self, MSG_INFO, 'Comanda', 'Selecione uma comanda.')
        else:
            self._vendedor_id = 0
            self._nome_vendedor = None
            self.ui.edt_comanda.clear()
            self.ui.stackedWidget.setCurrentIndex(1)

    @log
    def clear_widget_table(self, table):
        # Apaga lista de itens
        rows_count = table.rowCount()
        table.horizontalHeader().setVisible(True)
        # Verifica se hà dados
        if rows_count:
            rows = range(0, rows_count + 1)
            rows.reverse()
            for r in rows:
                table.removeRow(r)
        return rows_count

    @log
    def _update_table_item(self, id_pve):
        self.clear_widget_table(self.ui.tableItens)
        corpos = SupervisorCdaCorpo.query.filter(SupervisorCdaCorpo.supcdo_capa_id == id_pve). \
            order_by('supcdo_sequencia_id')
        for c in corpos:
            item = SupervisorCadItens.get_by(supite_codigo_item=c.supcdo_item,
                                             supite_loja=self.loja.supcfc_loja)
            vend = SupervisorCadVendedor.get_by(supven_codigo=c.supcdo_cod_vendedor)
            icon3 = QtGui.QIcon()
            if c.supcdo_venda_cancelamento == 'V':
                icon3.addPixmap(
                    QtGui.QPixmap(os.path.join(root_path, "resources/16x16/check2.png")),
                    QtGui.QIcon.Normal, QtGui.QIcon.Off)
            else:
                icon3.addPixmap(
                    QtGui.QPixmap(os.path.join(root_path, "resources/16x16/delete.png")),
                    QtGui.QIcon.Normal, QtGui.QIcon.Off)
            table_item = self.ui.tableItens
            row = table_item.rowCount()
            table_item.insertRow(row)
            # Codigo Item
            item_check = QtGui.QTableWidgetItem('')
            item_check.setIcon(icon3)
            # Codigo Item
            item_cod = QtGui.QTableWidgetItem(c.supcdo_item)
            # Descrição
            item_name = item.name if config['descricao_resumida'] else item.supite_descricao_completa
            item_descr = QtGui.QTableWidgetItem(item_name)
            # Quantidade
            item_qtda = QtGui.QTableWidgetItem('%1.3f' % c.supcdo_quantidade)
            # Valor Unitário
            item_vuni = QtGui.QTableWidgetItem('R$ %1.2f' % item.supite_preco)
            # Total
            item_total = QtGui.QTableWidgetItem('R$ %1.2f' % c.supcdo_preco_total)
            # Vendedor
            if vend:
                item_vend = QtGui.QTableWidgetItem(vend.name)
            else:
                item_vend = QtGui.QTableWidgetItem(self._vendedor_id)

            # WidGET OS NEW ITENS NA TABLE ITENS
            table_item.setItem(row, 0, item_check)
            table_item.setItem(row, 1, item_cod)
            table_item.setItem(row, 2, item_descr)
            table_item.setItem(row, 3, item_qtda)
            table_item.setItem(row, 4, item_vuni)
            table_item.setItem(row, 5, item_total)
            table_item.setItem(row, 6, item_vend)
            if modulo_instalado_producao_comanda and item.supite_producao == 'P' \
                    and c.supcdo_venda_cancelamento == 'V':
                table_item.setRowHeight(row, 40)
                icon4 = QtGui.QIcon()
                icon4.addPixmap(
                    QtGui.QPixmap(os.path.join(root_path, "ui/img/printer.png")),
                    QtGui.QIcon.Normal, QtGui.QIcon.Off)
                item_printer = QtGui.QTableWidgetItem('')
                item_printer.setIcon(icon4)
                table_item.setItem(row, 7, item_printer)
                if c.supcdo_observacao:
                    icon5 = QtGui.QIcon()
                    icon5.addPixmap(
                        QtGui.QPixmap(os.path.join(root_path, "ui/img/obs.png")),
                        QtGui.QIcon.Normal, QtGui.QIcon.Off)
                    item_obs = QtGui.QTableWidgetItem('')
                    item_obs.setIcon(icon5)
                    table_item.setItem(row, 8, item_obs)

            table_item.resizeColumnsToContents()
            table_item.scrollToBottom()

    @log
    def editar_pve(self, id_pve, ro=True):
        self.ui.editMesa.setText('')
        self._vendedor_id = 0
        self._nome_vendedor = None
        self._clear_widgets()
        self._pve = pve = SupervisorCdaCapa.get_by(id=id_pve)
        self.ui.stackedWidget.setCurrentIndex(0)
        self.ui.editNumPve.setText('%d' % pve.supcda_codigo_comanda)
        d = pve.supcda_data_hora.timetuple()
        d = QtCore.QDateTime(d[0], d[1], d[2], d[3], d[4], d[5])
        self.ui.dateEmissaoPve.setDateTime(d)
        self.ui.comboStatusPve.setCurrentIndex(0)
        if pve.supcda_cliente:
            self.ui.editDocCliente.setText(
                '[%s] %s' % (pve.supcda_cliente, pve.supcda_nome_cliente))

        if modulo_instalado_producao_comanda:
            self.ui.editMesa.setText('%s' % (pve.supcda_mesa or ''))

        self.ui.spinTotalPve.setValue(pve.supcda_total_comanda)
        self.ui.comboStatusPve.setCurrentIndex(pve.supcda_restricao)
        self._update_table_item(id_pve)
        self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
        self.ui.frame_esquerdo.setEnabled(ro)
        self.ui.buttonBuscarCliente.setEnabled(ro)

    @log
    def _cancela_item(self, *args):
        if not self.ui.tableItens.rowCount():
            return message_dlg(self, MSG_INFO, 'Comanda', 'Não há itens lançados.')
        if not self.ui.tableItens.selectedItems():
            return message_dlg(self, MSG_INFO, 'Comanda', 'Selecione um item.')
        row = self.ui.tableItens.currentRow()
        tb_item = self.ui.tableItens.item(row, 0)
        item_des = self.ui.tableItens.item(row, 2).text()
        item_vr = self.ui.tableItens.item(row, 5).text()
        item = SupervisorCdaCorpo.get_by(supcdo_capa_id=self._pve.id, supcdo_sequencia_id=row + 1)
        item_cancel = str(str(row + 1) + '-' + item_des)

        if item.supcdo_venda_cancelamento == 'C':
            return message_dlg(self, MSG_ERROR, 'Item: %s já foi cancelado.' % item_cancel)

        cancela = False
        if self._operador.supope_cancela_item == 'N' and self._operador.supope_operador_supervisor == 'O':
            dlg = dlg_pwd(self, msg_info='Cancelamento de Item')
            if dlg.exec_():
                if dlg.user.CancelaItem == 'S':
                    cancela = True
                else:
                    return message_dlg(self, MSG_INFO,
                                       'Operador: %s.\n\nNão tem permissão para executar esta operação' %
                                       dlg.user.name)
            else:
                return message_dlg(self, MSG_INFO, 'Operação Cancelada!!!')
        else:
            cancela = True

        if message_dlg(self, MSG_QUESTION,
                       'Deseja cancelar o item:\n%s' % item_cancel) != YES_ROLE and cancela:
            return

        else:
            try:
                total = exec_sql("""SELECT supcda_total_comanda 
                                    FROM supervisor_cda_capa 
                                    WHERE id = 
                                    %s""" % self._pve.id, 'S')[0].get('supcda_total_comanda')
                total = total - Decimal(item_vr.split(' ')[-1])
                b_sess.begin()
                self._pve.supcda_total_comanda = total
                item.supcdo_venda_cancelamento = 'C'
                item.supcdo_imprimir = '1'
                b_sess.commit()
                # Limpar a o widget table
                self.ui.spinTotalPve.setValue(total)
                if not SupervisorCdaCorpo.get_by(supcdo_capa_id=self._pve.id,
                                                 supcdo_venda_cancelamento='V'):
                    self._pve.supcda_restricao = 0
            except Exception as e:
                b_sess.rollback()
                return self.exception_message_box(str(e))

        icon3 = QtGui.QIcon()
        icon3.addPixmap(QtGui.QPixmap(os.path.join(root_path, "resources/16x16/delete.png")),
                        QtGui.QIcon.Normal, QtGui.QIcon.Off)
        tb_item.setIcon(icon3)
        if modulo_instalado_producao_comanda:
            self.ui.tableItens.setRowHeight(row, 40)
            item_printer = QtGui.QTableWidgetItem('')
            self.ui.tableItens.setItem(row, 7, item_printer)
            item_obs = QtGui.QTableWidgetItem('')
            self.ui.tableItens.setItem(row, 8, item_obs)


    @log
    def _calcula_total(self, *args):
        total = self.ui.spinVlItem.value() * (self.ui.spinQtda.value() - self.ui.spinTara.value())
        self.ui.spinVlTotal.setValue(total)
        return total

    @log
    def _button_busca_cliente_click(self, *args):
        busca_cli_form = BuscaCliente(self, 'S')

        if self._pve:
            if self._pve.supcda_cliente:
                return message_dlg(self, MSG_ERROR,
                                   'Já existe um cliente selecionado para essa comanda.')

        if busca_cli_form.exec_():
            self._cli = busca_cli_form.retorno
            self.ui.editDocCliente.setText('[%s] %s' % (self._cli.supcli_cnpj_cpf, self._cli.name))
            if self._pve:
                b_sess.begin()
                if self._cli and not self._pve.supcda_cliente:
                    self._pve.supcda_cliente = self._cli.supcli_cnpj_cpf
                    self._pve.supcda_nome_cliente = self._cli.name
                b_sess.commit()


    @log
    def KEY_VENDEDOR_Click(self):
        self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
        self.ui.label_edit_1.setText(u'Código do Vendedor')
        self.ui.editCodItem.clear()

    @log
    def KEY_QUANTIDADE_Click(self):
        self.ui.spinQtda.setDecimals(3)
        self.setControlFocus(self._CONTROL_FOCUS, self.ui.spinQtda)

    @log
    def cellpressed_tableItens(self, row, column):
        if column not in (7, 8) or not modulo_instalado_producao_comanda:
            return

        corpo = SupervisorCdaCorpo.get_by(supcdo_capa_id=self._pve.id,
                                          supcdo_sequencia_id=row + 1)

        if corpo.supcdo_venda_cancelamento != 'V':
            return u'Item cancelado'

        item = SupervisorCadItens.get_by(supite_codigo_item=corpo.supcdo_item,
                                         supite_loja=self.loja.supcfc_loja)
        if item.supite_producao != 'P':
            return u'Item nao eh de producao'

        if column == 7: # manda imprimir novamente
            b_sess.begin()
            corpo.supcdo_imprimir = '2'
            b_sess.commit()
            message_dlg(self, MSG_INFO, u'Reimpressão enviada!')

        elif column == 8: # Ver observação
            self.obs_produto = corpo.supcdo_observacao or ''
            if self.obs_produto:
                BuscaObsProduto(self, True).exec_()

        return 'Linha: %s Coluna: %s' %(row+1, column+1)


    @log
    def _button_nova_pve_click(self, *args):
        self.setControlFocus(self._CONTROL_FOCUS, self.ui.edt_comanda)
        self.ui.buttonCancelarPVE.setStyleSheet("/buttons/images/buttons/disabled.png;")

    @log
    def _seleciona_favorito1(self):
        ''' Manda o codigo do protuto pelo botao selecionado
        '''
        for fav in self._dict_favoritos:
            if not fav == 'btnFavorito1':
                continue
            self.ui.editCodItem.setText(str(self._dict_favoritos.get(fav)))
            self._button_add_item_click()
            break

    @log
    def _seleciona_favorito2(self):
        ''' Manda o codigo do protuto pelo botao selecionado
        '''
        for fav in self._dict_favoritos:
            if not fav == 'btnFavorito2':
                continue
            self.ui.editCodItem.setText(str(self._dict_favoritos.get(fav)))
            self._button_add_item_click()
            break

    @log
    def _seleciona_favorito3(self):
        ''' Manda o codigo do protuto pelo botao selecionado
        '''
        for fav in self._dict_favoritos:
            if not fav == 'btnFavorito3':
                continue
            self.ui.editCodItem.setText(str(self._dict_favoritos.get(fav)))
            self._button_add_item_click()
            break

    @log
    def _seleciona_favorito4(self):
        ''' Manda o codigo do protuto pelo botao selecionado
        '''
        for fav in self._dict_favoritos:
            if not fav == 'btnFavorito4':
                continue
            self.ui.editCodItem.setText(str(self._dict_favoritos.get(fav)))
            self._button_add_item_click()
            break

    @log
    def _seleciona_favorito5(self):
        ''' Manda o codigo do protuto pelo botao selecionado
        '''
        for fav in self._dict_favoritos:
            if not fav == 'btnFavorito5':
                continue
            self.ui.editCodItem.setText(str(self._dict_favoritos.get(fav)))
            self._button_add_item_click()
            break

    @log
    def _seleciona_favorito6(self):
        ''' Manda o codigo do protuto pelo botao selecionado
        '''
        for fav in self._dict_favoritos:
            if not fav == 'btnFavorito6':
                continue
            self.ui.editCodItem.setText(str(self._dict_favoritos.get(fav)))
            self._button_add_item_click()
            break

    @log
    def add_favoritos(self):
        '''
            Define o texto e quais botoes favoritos vao aparecer
        '''
        self.ui.frmKeysDirection_favoritos.setVisible(True)
        self.ui.btnFavorito1.setVisible(False)
        self.ui.btnFavorito2.setVisible(False)
        self.ui.btnFavorito3.setVisible(False)
        self.ui.btnFavorito4.setVisible(False)
        self.ui.btnFavorito5.setVisible(False)
        self.ui.btnFavorito6.setVisible(False)
        # este dicionario vai associar o codigo do produto com o botao
        dict_favoritos = {}
        self.ui.frmKeysDirection_favoritos.setMinimumSize(self.ui.frmKeysDirection_favoritos.minimumWidth(), 200)
        itens_favoritos = SupervisorCdaItensFavoritos.query.filter().order_by('supifa_botao').all()
        botoes_usados = {}
        for item in itens_favoritos:
            descricao = remove_accents(item.supifa_botao_descricao)
            codigo = SupervisorCadItens.get_by(id=item.supifa_item_id,
                                               supite_loja=self.loja.supcfc_loja).\
                                               supite_codigo_item
            if len(descricao) > 13:
                descricao = descricao[:13] + '\n' + descricao[13:]
            if not botoes_usados:
                botoes_usados[1] = True
                self.ui.btnFavorito1.setText(descricao)
                self.ui.btnFavorito1.setVisible(True)
                dict_favoritos[self.ui.btnFavorito1.objectName()] = codigo
            elif not botoes_usados.get(2):
                botoes_usados[2] = True
                self.ui.btnFavorito2.setText(descricao)
                self.ui.btnFavorito2.setVisible(True)
                dict_favoritos[self.ui.btnFavorito2.objectName()] = codigo
            elif not botoes_usados.get(3):
                botoes_usados[3] = True
                self.ui.btnFavorito3.setText(descricao)
                self.ui.btnFavorito3.setVisible(True)
                dict_favoritos[self.ui.btnFavorito3.objectName()] = codigo
            elif not botoes_usados.get(4):
                botoes_usados[4] = True
                self.ui.btnFavorito4.setText(descricao)
                self.ui.btnFavorito4.setVisible(True)
                dict_favoritos[self.ui.btnFavorito4.objectName()] = codigo
            elif not botoes_usados.get(5):
                botoes_usados[5] = True
                self.ui.btnFavorito5.setText(descricao)
                self.ui.btnFavorito5.setVisible(True)
                dict_favoritos[self.ui.btnFavorito5.objectName()] = codigo
            elif not botoes_usados.get(6):
                botoes_usados[6] = True
                self.ui.btnFavorito6.setText(descricao)
                self.ui.btnFavorito6.setVisible(True)
                dict_favoritos[self.ui.btnFavorito6.objectName()] = codigo

        self._dict_favoritos = dict_favoritos
        return True

    @log
    def _pressed_editMesa(self):
        if self._pve and self.ui.editMesa.text():
            b_sess.begin()
            self._pve.supcda_mesa = int(self.ui.editMesa.text())

            b_sess.commit()

        self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
        return True


    @log
    def _button_filtro_cod_pve_click(self):
        codigo_comanda = self.ui.edt_comanda.text()
        log.info('Código comanda: %s' % str(codigo_comanda))
        try:
            int(codigo_comanda)
            cd = int(codigo_comanda)
            comanda = SupervisorCdaCapa.query.filter(SupervisorCdaCapa.supcda_codigo_comanda == cd).filter(
                SupervisorCdaCapa.supcda_restricao == 0).all()
            if comanda:
                if self._cancelar_comanda:
                    self._cancelar_pve(comanda)
                    self.ui.buttonCancelarPVE.setStyleSheet("/buttons/images/buttons/disabled.png;")
                else:
                    self.add_favoritos()
                    self.editar_pve(comanda[0].id)
            else:
                if self._cancelar_comanda:
                    return message_dlg(self, MSG_INFO, 'Comanda não encontrada')
                else:
                    self._cli = ''
                    self._pve = None
                    self._clear_widgets()
                    self.ui.frame_esquerdo.setEnabled(True)
                    self.ui.buttonBuscarCliente.setEnabled(True)
                    self._codigo_comanda = int(codigo_comanda)
                    self.ui.editNumPve.setText('%d' % self._codigo_comanda)
                    self.ui.stackedWidget.setCurrentIndex(0)
                    self.ui.dateEmissaoPve.setDateTime(QtCore.QDateTime.currentDateTime())
                    if modulo_instalado_producao_comanda:
                        self.setControlFocus(self._CONTROL_FOCUS, self.ui.editMesa)
                    else:
                        self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)

                    self.add_favoritos()
        except ValueError:
            self.ui.edt_comanda.clear()
            return message_dlg(None, MSG_ERROR, 'O código da comanda deve ser numérico! \n\n'
                                                'Código informado: %s' % codigo_comanda)
        except Exception as err:
            log.error(str(err))

    @log
    def editcoditem(self):
        self._button_add_item_click()

    @log
    def _button_busca_item_click(self):
        cod_item = self.ui.editCodItem.text()
        item = res = prod = None
        conexao = testa_conexao_pg(config['db_sup_name'],
                                   config['db_sup_user'],
                                   config['db_sup_host'],
                                   config['db_sup_pass'])
        if not conexao or not conexao.get('res'):
            message_dlg(self, MSG_INFO,
                           'Sem conexão com o Supervisor!')
            return False

        if not cod_item:
            return False
        log.info('Codigo Item: %s' % str(cod_item))
        if self.ui.label_edit_1.text() == u'Cód. do Produto:':


            item = SupervisorCadItens.get_by(supite_codigo_item=cod_item.rjust(14, '0'),
                                             supite_loja=self.loja.supcfc_loja, active='T')
            if item:
                item_name = item.name if config['descricao_resumida'] else item.supite_descricao_completa
                item_name = remove_accents(unicode(item_name))
                peso_tara = 0.0
                qtd = self.ui.spinQtda.value()
                if item.supite_peso_tara:
                    peso_tara = item.supite_peso_tara
                self.ui.spinTara.setValue(peso_tara)
                if qtd < peso_tara:
                    message_dlg(self, MSG_INFO,
                                "Peso da tara cadastrado para \n %s "
                                "\n é maior que o peso obtido. \n"
                                "\nPeso da tara: %s"
                                "\nPeso obtido: %s" % (
                                    str(item_name), Decimal(peso_tara).quantize(TREEPLACES),
                                    Decimal(qtd).quantize(TREEPLACES)))
                self.ui.editCodItem.setText(item.supite_codigo_item)
                self.ui.spinVlItem.setValue(item.supite_preco)
                self._calcula_total()
                self.ui.labelItem.setText(item_name)
                prod = item
            else:
                busca_produto_form = BuscaProduto(self)
                if busca_produto_form.exec_():
                    res = busca_produto_form.retorno
                    if res:
                        item_name = res.name if config['descricao_resumida'] else res.supite_descricao_completa
                        item_name = remove_accents(unicode(item_name))
                        qtd = self.ui.spinQtda.value()
                        peso_tara = 0.0
                        if res.supite_peso_tara:
                            peso_tara = res.supite_peso_tara
                        self.ui.spinTara.setValue(peso_tara)
                        if qtd < peso_tara:
                            message_dlg(self, MSG_INFO,
                                        "Peso da tara cadastrado para \n %s "
                                        "\n é maior que o peso obtido. \n"
                                        "\nPeso da tara: %s"
                                        "\nPeso obtido: %s" % (
                                            str(item_name),
                                            Decimal(peso_tara).quantize(TREEPLACES),
                                            Decimal(qtd).quantize(TREEPLACES)))
                        self.ui.editCodItem.setText(res.supite_codigo_item)
                        self.ui.spinVlItem.setValue(res.supite_preco)
                        self._calcula_total()
                        self.ui.labelItem.setText(item_name)
                        prod = res
                else:
                    self.ui.editCodItem.selectAll()
            if prod and config['itempesavelcomanda']:
                if prod.supite_pesavel is True:
                    balanca = self.KEY_BALANCA_Click()
                    self.setControlFocus(self._CONTROL_FOCUS, self.ui.spinQtda)
                    self.ui.spinQtda.selectAll()
                    if not balanca:
                        self.ui.editCodItem.setText(cod_item)
                        self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
                        self.ui.editCodItem.selectAll()
                        return False

        elif self.ui.label_edit_1.text() == u'Código do Vendedor':
            try:
                vendedor = SupervisorCadVendedor.get_by(supven_codigo=cod_item)
                if vendedor:
                    if self._vendedor_id != vendedor.supven_codigo:
                        self._vendedor_id = vendedor.supven_codigo
                        self._nome_vendedor = vendedor.name
                        message_dlg(self, MSG_INFO,
                                    '<h2>Vendedor selecionado:</h2></br></br><h2 align="center" '
                                    'style="text-align: center;"><strong>'
                                    '<span style="color:#FF0000;">%03d - %s</span></strong></h2>'
                                    % (vendedor.supven_codigo, vendedor.name))
                    else:
                        message_dlg(self, MSG_INFO,
                                    '<h2>Você já é o vendedor selecionado!</h2>')
                else:
                    message_dlg(self, MSG_INFO,
                                '<h2>Vendedor %s não cadastrado!</h2>' % cod_item)
            except Exception as err:
                log.error(str(err.message))
                message_dlg(self, MSG_INFO, '<h2>Vendedor não cadastrado!</h2>')

            self.ui.label_edit_1.setText(u'Cód. do Produto:')
            self.ui.editCodItem.clear()

        return item

    @log
    def _button_add_item_click(self):
        try:
            item = self._button_busca_item_click()
            if item:
                self._adicionar_item(item)
        except Exception as e:
            self.exception_message_box(str(e))

    @log
    def _adicionar_item(self, item):
        # GET
        if not self._pve:
            self.gerar_capa_pve(self._codigo_comanda)
        if self._pve.supcda_restricao == 5:
            message_dlg(self, MSG_INFO,
                        'Não posso vender mais item para essa comanda.\n\n'
                        'Comanda está sendo faturada no caixa.')
            self.ui.stackedWidget.setCurrentIndex(1)
            self.ui.labelItem.clear()
            self.ui.edt_comanda.clear()
            return False

        elif self._pve.supcda_restricao == 2:
            message_dlg(self, MSG_INFO,
                        'Não posso vender mais item nessa comanda.\n\n'
                        'Comanda faturada.')
            self.ui.stackedWidget.setCurrentIndex(1)
            self.ui.labelItem.clear()
            self.ui.edt_comanda.clear()
            return False

        self._update_table_item(self._pve.id)
        cod = item.supite_codigo_item
        item_name = item.name if config['descricao_resumida'] else item.supite_descricao_completa
        descr = item_name
        qtda = Decimal(str(self.ui.spinQtda.value() - self.ui.spinTara.value())).quantize(
            TREEPLACES)
        vuni = item.supite_preco

        if not qtda:
            self.setControlFocus(self._CONTROL_FOCUS, self.ui.spinQtda)
            self.ui.spinQtda.setValue(1)
            return message_dlg(self, MSG_INFO, 'Favor, informe a quantidade desejada.')
            # VERIFICAR QUANTidADE MIN/MAX

        conexao = testa_conexao_pg(config['db_sup_name'],
                                   config['db_sup_user'],
                                   config['db_sup_host'],
                                   config['db_sup_pass'])
        if not conexao or not conexao.get('res'):
            message_dlg(self, MSG_INFO,
                           'Sem conexão com o Supervisor!')
            return False

        if self.parametro:
            qtd_min = self.parametro.supcfp_qtd_minima if self.parametro.supcfp_qtd_minima else 0
            qtd_max = self.parametro.supcfp_qtd_maxima if self.parametro.supcfp_qtd_maxima else 0
            msg_qtda = ''
            qtd_min = Decimal(str(qtd_min)).quantize(TREEPLACES)
            qtd_max = Decimal(str(qtd_max)).quantize(TREEPLACES)
            if qtda < qtd_min:
                msg_qtda = 'Qtda. digitada menor que a permitida!'
            elif qtda > qtd_max:
                msg_qtda = 'Qtda. digitada maior que a permitida!'
            if msg_qtda:
                self.ui.spinQtda.setFocus()
                self.ui.spinQtda.setValue(1)
                return message_dlg(self, MSG_INFO, 'PVE', msg_qtda)

        if item.supite_fracionado:
            self.ui.spinQtda.setDecimals(3)
        else:
            if not Decimal(self.ui.spinQtda.text().replace(',', '.'))._isinteger():
                msg = '<center>A quantidade <h2><font color="red">{0!s}</font></h2> para o item  ' \
                      '<h3><font color="red">{1!s}</font></h3> não pode ser ' \
                      'fracionada.</center>'.format(self.ui.spinQtda.text(), item_name)
                self.ui.spinQtda.setValue(1)
                message_dlg(self, MSG_INFO, msg)
                return False

        total = Decimal(str(self.ui.spinVlTotal.value()))
        obs = ''
        vr_tot = Decimal(vuni * qtda)
        if modulo_instalado_producao_comanda and item.supite_producao == 'P':
            BuscaObsProduto(self).exec_()
            obs = self.obs_produto

        try:
            dados_seq = exec_sql("""SELECT MAX(supcdo_sequencia_id) AS sequencia,
                                           SUM(CASE WHEN supcdo_venda_cancelamento = 'V'
                                                    THEN supcdo_preco_total
                                                    ELSE 0
                                               END)  AS total
                                                FROM supervisor_cda_corpo 
                                                WHERE supcdo_capa_id = %s""" % self._pve.id, 'S')
            sequencia = 1
            total_pve = 0
            if dados_seq:
                sequencia = (dados_seq[0].get('sequencia') or 0) + 1
                total_pve = dados_seq[0].get('total') or 0

            create_date = datetime.utcnow()
            b_sess.begin()
            self._pve.supcda_total_comanda = total_pve + total
            b_sess.commit()
            self.ui.spinVlTotal.setValue(total_pve + total)
            b_sess.begin()
            if modulo_instalado_producao_comanda:
                if item.supite_producao == 'P':
                    SupervisorCdaCorpo(create_date=create_date,
                                       supcdo_capa_id=self._pve.id,
                                       supcdo_sequencia_id=sequencia,
                                       supcdo_item=cod,
                                       supcdo_quantidade=qtda,
                                       supcdo_preco_total=total,
                                       supcdo_cod_vendedor=self._vendedor_id,
                                       supcdo_nome_vendedor=self._nome_vendedor,
                                       supcdo_observacao=obs,
                                       supcdo_seq_impressao=0,
                                       supcdo_imprimir='2',
                                       supcdo_entregue=False,
                                       supcdo_venda_cancelamento='V')
                else:
                    SupervisorCdaCorpo(create_date=create_date,
                                       supcdo_capa_id=self._pve.id,
                                       supcdo_sequencia_id=sequencia,
                                       supcdo_item=cod,
                                       supcdo_quantidade=qtda,
                                       supcdo_preco_total=total,
                                       supcdo_cod_vendedor=self._vendedor_id,
                                       supcdo_nome_vendedor=self._nome_vendedor,
                                       supcdo_observacao=obs,
                                       supcdo_seq_impressao=0,
                                       supcdo_imprimir='1',
                                       supcdo_entregue=False,
                                       supcdo_venda_cancelamento='V'
                                       )
            else:
                SupervisorCdaCorpo(create_date=create_date,
                                   supcdo_capa_id=self._pve.id,
                                   supcdo_sequencia_id=sequencia,
                                   supcdo_item=cod,
                                   supcdo_quantidade=qtda,
                                   supcdo_preco_total=total,
                                   supcdo_cod_vendedor=self._vendedor_id,
                                   supcdo_nome_vendedor=self._nome_vendedor,
                                   supcdo_venda_cancelamento='V')
            b_sess.commit()
        except Exception as e:
            self.exception_message_box(str(e))
        icon3 = QtGui.QIcon()
        icon3.addPixmap(QtGui.QPixmap(os.path.join(root_path, "resources/16x16/check2.png")),
                        QtGui.QIcon.Normal, QtGui.QIcon.Off)
        table_item = self.ui.tableItens
        row = table_item.rowCount()
        table_item.insertRow(row)
        # Codigo Item
        item_check = QtGui.QTableWidgetItem('')
        item_check.setIcon(icon3)
        # Codigo Item
        item_cod = QtGui.QTableWidgetItem(cod)
        # Descrição
        item_descr = QtGui.QTableWidgetItem(descr)
        # Quantidade
        item_qtda = QtGui.QTableWidgetItem('%1.3f' % qtda)
        # Valor Unitário
        item_vuni = QtGui.QTableWidgetItem('R$ %1.2f' % vuni)
        # Total
        item_total = QtGui.QTableWidgetItem('R$ %1.2f' % total)
        # Vendedor
        vendedor = SupervisorCadVendedor.get_by(supven_codigo=self._vendedor_id)
        if vendedor:
            item_vend = QtGui.QTableWidgetItem(vendedor.name)
        else:
            item_vend = QtGui.QTableWidgetItem(self._vendedor_id)

        # WidGET OS NEW ITENS NA TABLE ITENS
        table_item.setItem(row, 0, item_check)
        table_item.setItem(row, 1, item_cod)
        table_item.setItem(row, 2, item_descr)
        table_item.setItem(row, 3, item_qtda)
        table_item.setItem(row, 4, item_vuni)
        table_item.setItem(row, 5, item_total)
        table_item.setItem(row, 6, item_vend)
        if modulo_instalado_producao_comanda and item.supite_producao == 'P':
            table_item.setRowHeight(row, 40)
            icon4 = QtGui.QIcon()
            icon4.addPixmap(
                QtGui.QPixmap(os.path.join(root_path, "ui/img/printer.png")),
                QtGui.QIcon.Normal, QtGui.QIcon.Off)
            item_printer = QtGui.QTableWidgetItem('')
            item_printer.setIcon(icon4)
            table_item.setItem(row, 7, item_printer)
            if obs:
                icon5 = QtGui.QIcon()
                icon5.addPixmap(
                    QtGui.QPixmap(os.path.join(root_path, "ui/img/obs.png")),
                    QtGui.QIcon.Normal, QtGui.QIcon.Off)
                item_obs = QtGui.QTableWidgetItem('')
                item_obs.setIcon(icon5)
                table_item.setItem(row, 8, item_obs)


        table_item.resizeColumnsToContents()
        table_item.scrollToBottom()
        self.ui.editCodItem.clear()
        self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
        self.ui.spinVlItem.setValue(0)
        self.ui.spinQtda.setValue(1)
        self.ui.spinTara.setValue(0)
        self.ui.spinVlTotal.setValue(0)
        self.ui.spinTotalPve.setValue(self.ui.spinTotalPve.value() + float(total))
        self.ui.labelItem.setText(u'Informe o Código do Produto')

    @log
    def clear_widget_table(self, table):
        # Apaga lista de itens
        rows_count = table.rowCount()
        # Verifica se hà dados
        if rows_count:
            rows = range(0, rows_count + 1)
            rows.reverse()
            for r in rows:
                table.removeRow(r)
        return rows_count

    @log
    def gerar_capa_pve(self, codigo_comanda):
        '''
        cria capa da comanda
        :param codigo_comanda:
        :return:
        '''
        self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
        try:
            cli_doc = cli_nome = None
            if self._cli:
                cli_doc = self._cli.supcli_cnpj_cpf
                cli_nome = self._cli.name

            b_sess.begin()
            if modulo_instalado_producao_comanda and self.ui.editMesa.text():
                self._pve = SupervisorCdaCapa(supcda_cliente=cli_doc, supcda_nome_cliente=cli_nome,
                                              supcda_restricao=0,
                                              supcda_operador=self._operador.supope_codigo,
                                              supcda_mesa=int(self.ui.editMesa.text()),
                                              supcda_codigo_comanda=int(codigo_comanda),
                                              supcda_data_hora=datetime.utcnow()) # greenwich
            else:
                self._pve = SupervisorCdaCapa(supcda_cliente=cli_doc, supcda_nome_cliente=cli_nome,
                                              supcda_restricao=0,
                                              supcda_operador=self._operador.supope_codigo,
                                              supcda_codigo_comanda=int(codigo_comanda),
                                              supcda_data_hora=datetime.utcnow())  # greenwich

            b_sess.commit()
            self.ui.comboStatusPve.setCurrentIndex(self._pve.supcda_restricao)
            self.ui.frame_esquerdo.setEnabled(True)
        except Exception as e:
            self.exception_message_box(str(e))
            b_sess.rollback()
            return
        return self._pve

    @log
    def keyPressEvent(self, ev):
        if ev.key() in (QtCore.Qt.Key_Return.__int__(), QtCore.Qt.Key_Enter.__int__()):
            if self.ui.spinQtda.hasFocus():
                self.setControlFocus(self._CONTROL_FOCUS, self.ui.editCodItem)
                self._button_add_item_click()
            elif self.ui.editCodItem.hasFocus():
                self._button_add_item_click()
            elif self.ui.dateIni.hasFocus() or self.ui.dateFim.hasFocus() \
                    or self.ui.editBuscaPve.hasFocus() or self.ui.comboFiltroStatus.hasFocus():
                self.filter_pve()
            elif self.ui.edt_comanda.hasFocus():
                self._button_filtro_cod_pve_click()
            elif modulo_instalado_producao_comanda and self.ui.editMesa.hasFocus():
                self._pressed_editMesa()


@log
def start():
    app = QtGui.QApplication(sys.argv)
    SingleInstance('comanda')
    login_form = LoginForm(db='S')
    exec_form = login_form.exec_()
    if exec_form:
        form = RestauranteForm(operador=login_form.retorno)
        form.setWindowTitle(u'SigPDV - Restaurante')
        form.showFullScreen()
        app.exec_()
    else:
        sys.exit(-1)


if __name__ == "__main__":
    try:
        start()
    except Exception as e:
        exception_message_box(str(e))
        sys.exit(-1)
