#!/usr/bin/env python
# -*- coding: utf-8 -*-

__author__ = 'Dener Rodrigues'

import os
import platform
import socket
import fcntl
import struct
import array
import subprocess

SIOCGIFNETMASK = 0x891b


def get_network_mask(ifname):
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    netmask = fcntl.ioctl(s, SIOCGIFNETMASK, struct.pack('256s', ifname))[20:24]
    return socket.inet_ntoa(netmask)


def get_ip_address(ifname):
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    res = socket.inet_ntoa(fcntl.ioctl(s.fileno(), 0x8915, struct.pack('256s', ifname[:15]))[20:24])
    return res


def get_gateway(ifname):
    cmd = "ip route list dev " + ifname + " | awk ' /^default/ {print $3}'"
    fin, fout = os.popen4(cmd)
    result = fout.read()
    return result


def get_ip():
    ip = '0.0.0.0'
    sub_process = subprocess.Popen(['hostname', '-I'], stdout=subprocess.PIPE)
    out, err = sub_process.communicate()
    try:
        ip = out.split()[0]
    except Exception:
        pass

    return ip


if __name__ == '__main__':
    try:
        print get_ip()
    except Exception:
        pass