# -*- coding: utf-8 -*-

__author__ = 'christian.douglas'

import xmlrpclib
import httplib
from sys import hexversion

def ServerProxy(url, *args, **kwargs):
    t = TimeoutTransport()
    t.timeout = kwargs.pop('timeout', 20)
    kwargs['transport'] = t
    return xmlrpclib.ServerProxy(url, *args, **kwargs)

class TimeoutTransport(xmlrpclib.Transport):
    def make_connection(self, host):
        if hexversion < 0x02070000:
            conn = TimeoutHTTP(host)
            conn.set_timeout(self.timeout)
        else:
            conn = TimeoutHTTPConnection(host)
            conn.timeout = self.timeout
        return conn

class TimeoutHTTPConnection(httplib.HTTPConnection):
    def connect(self):
        httplib.HTTPConnection.connect(self)
        self.sock.settimeout(self.timeout)

class TimeoutHTTP(httplib.HTTP):
    _connection_class = TimeoutHTTPConnection

    def set_timeout(self, timeout):
        self._conn.timeout = timeout

if __name__ == "__main__":
    #
    # TESTE
    #
    server = 'localhost'
    sock_common = ServerProxy('http://%s:8069/xmlrpc/common' % server,timeout=2)
    #sock_common = xmlrpclib.ServerProxy ('http://%s:8069/xmlrpc/common' % server)

    uid = sock_common.login('NF112012', 'admin', 'admin')

    #replace localhost with the address of the server
    sock = xmlrpclib.ServerProxy('http://%s:8069/xmlrpc/object' % server)

    pedido_ids = sock.execute('NF112012', uid, 'admin', 'estoquepedidos.pedido.capa', 'search', [])

    print pedido_ids