# !/usr/bin/python
# -*- encoding: utf-8 -*-
__author__ = 'christian.douglas'
import os
import re
import glob
from datetime import datetime
from datetime import timedelta
import os.path
import re
import random
from sigpdv import root_path


def key_generator(size=6, shuffle=True):
    l = []
    for x in range(size):
        l.append('%s' % random.randint(0, 9))
    if shuffle:
        random.shuffle(l)
    return ''.join(l)


class bcolors:
    HEADER = '\033[95m'
    OKBLUE = '\033[01;94m'
    OKGREEN = '\033[92m'
    WARNING = '\033[93m'
    FAIL = '\033[91m'
    ENDC = '\033[0m'
    INFO = '\033[01;32m'
    T = '\033[00;37m'


def get_svn_revision(path=None):
    """
    Returns the SVN revision in the form SVN-XXXX,
    where XXXX is the revision number.

    Returns SVN-unknown if anything goes wrong, such as an unexpected
    format of internal SVN files.

    If path is provided, it should be a directory whose SVN info you want to
    inspect. If it's not provided, this will use the root django/ package
    directory.
    """
    rev = None
    entries_path = '%s/.svn/entries' % path

    try:
        entries = open(entries_path, 'r').read()
    except IOError:
        pass
    else:
        # Versions >= 7 of the entries file are flat text.  The first line is
        # the version number. The next set of digits after 'dir' is the revision.
        if re.match('(\d+)', entries):
            rev_match = re.search('\d+\s+dir\s+(\d+)', entries)
            if rev_match:
                rev = rev_match.groups()[0]
        # Older XML versions of the file specify revision as an attribute of
        # the first entries node.
        else:
            from xml.dom import minidom

            dom = minidom.parse(entries_path)
            rev = dom.getElementsByTagName('entry')[0].getAttribute('revision')

    if not rev:
        try:
            cmd = "svn info %s | grep -i revis\xc3\xa3o: | cut -d ' ' -f2" % root_path
            rev = os.popen(cmd).read().replace('\n', '')
        except Exception as err:
            return u'SVN-unknown'

    res = u'SVN-%s' % rev
    return res


def del_logs(interval, path):
    """
    Exclui arquivos no periodo informado
    """
    # TODO: implementar log
    print 'DEL FILES', interval, path
    ret = 0

    for f in os.listdir(path):
        if f.endswith('.log'):
            data = f.split('.')
            try:
                filedate = datetime.strptime(data[1], '%d-%m-%Y').date()
                file_date_i = filedate + timedelta(days=interval)
                if file_date_i <= datetime.today().date():
                    os.remove(os.path.join(path, f))
                    ret += 1
            except Exception as e:
                print 'erro', e
    print 'DEL FILES APAGOU %d ARQUIVOS' % ret
    return ret


FILE_PATTERNS = r'.+\.(py|sql|po|pot|mo|rst|ico)$'
ADD_FILES = ['sw.ini', 'pdvsig.sig']


def find_data_files(source, patterns=FILE_PATTERNS):
    file_matcher = re.compile(patterns, re.I)
    out = []
    exc = []
    for base, _, files in os.walk(source):
        cur_files = []
        for f in files:

            if file_matcher.match(f):
                cur_files.append(os.path.join(base, f))
            if f in ADD_FILES:
                cur_files.append(os.path.join(base, f))
                print '--', os.path.join(base, f)
        if cur_files:
            out.append(
                (base, cur_files))

    return out


import logging

# def debug(loggername):
#    logger = logging.getLogger(loggername)
#    def log_(enter_message, exit_message=None):
#        def wrapper(f):
#            def wrapped(*args, **kargs):
#                print args, kargs
#                logger.debug(enter_message)
#                r = f(*args, **kargs)
#                if exit_message:
#                    print exit_message
#                    logger.debug(exit_message)
#                return r
#            return wrapped
#        return wrapper
#    return log_
#
#my_debug = debug('my.logger')
#


if __name__ == '__main__':
    from decorators import LOG

    @LOG
    def teste(a, b, c=5):
        return a + b + c


    teste(1, 2, 3)