# -.- coding: utf-8 -.-

from PySide import QtCore
from PySide import QtGui
import sys
from sigpdv.gui.ui.ui_acres_desc import Ui_Dialog
from decimal import Decimal

class DlgAcrescDesc(QtGui.QDialog):
    def __init__(self, parent=None, tipo='D', valor=0):
        QtGui.QDialog.__init__(self, parent, QtCore.Qt.Dialog | QtCore.Qt.FramelessWindowHint)

        self.ui = Ui_Dialog()
        self.ui.setupUi(self)
        self.setAttribute(QtCore.Qt.WA_TranslucentBackground)
        self.setModal(True)

        # SINAIS
        QtCore.QObject.connect(self.ui.spin_valor, QtCore.SIGNAL("editingFinished()"), self._check)


        self._tipo = tipo
        self._valor = valor
        self.retorno = Decimal('0.00')

        str_lbl_caption = u'.: Desconto :.%s'
        str_vlr = ''


        if self._tipo == 'A':
            str_lbl_caption = u'::: Acréscimo :::%s'
        if self._valor:
            str_vlr = '\n(PVE R$: %.2f)' % self._valor
        self.ui.label_caption.setText(str_lbl_caption % str_vlr)

    def showEvent(self, ev):
        self.ui.spin_valor.selectAll()
        return super(DlgAcrescDesc, self).showEvent(ev)

    def _check(self):
        print '>>', self.ui.spin_valor.value()
        self.ui.spin_valor.setFocus()


    def done(self, ev):
        valor = self.ui.spin_valor.value()
        if ev and valor:
            #Valor percentual
            if self.ui.radioButton.isChecked():
                self.retorno = (Decimal(str(valor)) / 100 * self._valor)
            #Valor em reais
            elif self.ui.radioButton_2.isChecked():
                self.retorno = Decimal(str(valor))
        return super(DlgAcrescDesc, self).done(ev)


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    dlg_acresc_desc = DlgAcrescDesc(valor=12)
    dlg_acresc_desc.exec_()
    print repr(dlg_acresc_desc.retorno)

