#!/usr/bin/python
# -*- coding: utf-8 -*-

from sigpdv.tools.log import traced as Log
from sigpdv.models.db_utils import exec_sql


class CadWebsig(object):
    def __init__(self, parent=None):
        self.parent = parent
        self.criar_registros()
        self.executar_sentenca()

    @Log
    def criar_registros(self):
        arq = open('web_sig/websig_sql_data.py', 'r')
        funcoes = eval(''.join(arq.readlines())).get('funcoes')
        ids = map(lambda x: x.get('websig_sql_id'), funcoes)
        str_ids = "'" + "','".join(ids) + "'"
        try:
            _ids = exec_sql("""SELECT websig_sql_id AS id
                               FROM caixa_cad_websig
                               WHERE websig_sql_id IN (%s)""" % str_ids)
            if not _ids:
                raise

            _ids = (map(lambda y: y.get('id'), _ids))
            ids = filter(lambda x: x not in _ids, ids)
        except:
            pass

        sql_insert = """ INSERT INTO caixa_cad_websig(
                              websig_sql_id,
                              websig_sql_name,
                              websig_sql_obs,
                              websig_sql_momento,
                              websig_sql_tabela,
                              websig_sql_executado,
                              websig_sql_sentenca)
                         VALUES
                         """

        list_values = []
        for dado in funcoes:
            # retira as funcoes que já estao no banco
            if dado.get('websig_sql_id') not in ids or not ids:
                continue
            sentenca = dado.get('websig_sql_sentenca').replace('"', '""')
            sentenca = sentenca.replace("'", '"')
            values = """('{id}',
                         '{name}',
                         '{obs}',
                         '{momento}',
                         '{tabela}',
                         '{executado}',
                         '{sentenca}')
                         """.format(id=dado.get('websig_sql_id'),
                                    name=dado.get('websig_sql_name'),
                                    obs=dado.get('websig_sql_obs'),
                                    momento=dado.get('websig_sql_momento'),
                                    tabela=dado.get('websig_sql_tabela'),
                                    sentenca=sentenca,
                                    executado=dado.get('websig_sql_executado'))
            list_values.append(values)

        sql_insert += ','.join(list_values)
        try:
            if list_values:
                exec_sql(sql_insert, 'C')
        except Exception as e:
            Log.error("Erro ao criar WebSig: %s" % str(e))

        return True

    @Log
    def get_string_delimited(self, string, delimited_inicio, delimited_fim=None):
        if not delimited_fim:
            delimited_fim = delimited_inicio

        pos_i = string.find(delimited_inicio)

        if pos_i == -1:
            return False

        pos_f = string[pos_i+1:].find(delimited_fim)

        if pos_f == -1:
            return False

        return string[pos_i+1:pos_i+1+pos_f]

    @Log
    def _exec_funcoes(self, funcao, funcao_nome):
        exec funcao

        return eval(funcao_nome)

    @Log
    def executar_sentenca(self):
        sql = """SELECT *
                 FROM caixa_cad_websig
                 WHERE websig_sql_executado = 'N'
                 ORDER BY id"""
        dados_websig = exec_sql(sql, 'C')
        res = True
        for websig in dados_websig:
            _id = websig.get('id')
            websig_sql_id = websig.get('websig_sql_id')
            _sql = websig.get('websig_sql_sentenca').replace('"', "'")
            _sql = _sql.replace("''", '"""')
            values = dict(websig_sql_resultado='Ok', websig_sql_executado='S')

            try:
                if _sql.startswith('write'):
                    pass

                # este metodo somente tem efeito no ERP
                elif _sql.startswith('metodo:'):
                    pass

                elif _sql.startswith('execute:'):
                    try:
                        _comando = _sql[8:].strip()
                        _funcao = self.get_string_delimited(_sql, ' ', ':').strip()
                        res = self._exec_funcoes(_comando, _funcao)
                        Log.info('Script executado: %s\n%s' % (websig_sql_id, _comando))
                    except Exception as e:
                        values['websig_sql_executado'] = 'E'
                        values['websig_sql_resultado'] = e.message
                        raise e
                    else:
                        values['websig_sql_executado'] = res and 'S' or 'N'
                        values['websig_sql_resultado'] = True
                else:
                    try:
                        exec_sql(_sql.encode('utf-8'), 'C')
                        Log.info('Script executado: %s\n%s' % (websig_sql_id, _sql))
                    except Exception as e:
                        values = dict(websig_sql_resultado=e.message, websig_sql_executado='E')
                        raise e
                    else:
                        values = dict(websig_sql_resultado=True, websig_sql_executado='S')
            except Exception as e:
                Log.error('Erro de Script: %s' % str(e))
            else:
                res = True
            finally:
                str_values = ''
                for key in values:
                    if str_values:
                        str_values += ', '

                    if isinstance(values.get(key), str):
                        str_values += str(key) + "='%s'" % values.get(key)
                    else:
                        str_values += str(key) + '=' + str(values.get(key))

                sql = """UPDATE caixa_cad_websig SET %s WHERE id = %s """ % (str_values, _id)
                exec_sql(sql, 'C')

        return res



