{   "funcoes": [
        # {"websig_sql_id": "", # Numero do chamado + underline(_) + numero da versao a liberar
        #                       # EX: 92645_6E1
        #  "websig_sql_name": "", # nome da funcao
        #  "websig_sql_obs": "", # descricao da funcao
        #  "websig_sql_momento": "", # momento da execucao
        #  "websig_sql_tabela": "", # tabela que sofre a acao da funcao
        #  "websig_sql_executado": "", # controle das funcoes executadas
        #  "websig_sql_sentenca": "" # funcao a ser executada
        # },
        # Exemplos
        # Ex1: Sql puro
        {"websig_sql_id": "91022_6E1",
         "websig_sql_name": "Select na tabela de clientes",
         "websig_sql_obs": "Busca os clientes que estao bloqueados usando sql puro",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_clientes",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
         SELECT *
         FROM caixa_cad_clientes
         WHERE supcli_status = 'B'
          """
        },
        # Ex2: Funcao
        {"websig_sql_id": "91023_6E1",
         "websig_sql_name": "Select na tabela de clientes",
         "websig_sql_obs": "Mesmo exemplo anterio, mas usando funcao",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_clientes",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """execute:
def consulta_cliente_bloqueado(self):
    sql = " SELECT *
            FROM caixa_cad_clientes
            WHERE supcli_status = 'B' "
    return exec_sql(sql, 'C', auto_commit=False)
    """
        },
        #---------------------------------Fim dos exemplos------------------------------------------

        {"websig_sql_id": "83495_5H1",
         "websig_sql_name": "Alterar emissao dos impostos frente",
         "websig_sql_obs": "Alterar emissao dos impostos frente",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_capa,caixa_mov_corpos,caixa_cad_itens",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_capa DROP COLUMN supcap_vr_imposto;
ALTER TABLE caixa_mov_corpos DROP COLUMN supcor_vr_imposto;
ALTER TABLE caixa_cad_itens DROP COLUMN supite_aliquota_ibpt;

-- caixa_cad_itens--
ALTER TABLE caixa_cad_itens ADD COLUMN supite_aliquota_ibpt_fed numeric(4,2);
ALTER TABLE caixa_cad_itens ALTER COLUMN supite_aliquota_ibpt_fed SET DEFAULT 0.00;
ALTER TABLE caixa_cad_itens ADD COLUMN supite_aliquota_ibpt_est numeric(4,2);
ALTER TABLE caixa_cad_itens ALTER COLUMN supite_aliquota_ibpt_est SET DEFAULT 0.00;
ALTER TABLE caixa_cad_itens ADD COLUMN supite_aliquota_ibpt_mun numeric(4,2);
ALTER TABLE caixa_cad_itens ALTER COLUMN supite_aliquota_ibpt_mun SET DEFAULT 0.00;
ALTER TABLE caixa_cad_itens ADD COLUMN supite_ibpt_chave character(10);

-- caixa_mov_capa
ALTER TABLE caixa_mov_capa ADD COLUMN supcap_vr_imposto_fed numeric(10,2);
ALTER TABLE caixa_mov_capa ALTER COLUMN supcap_vr_imposto_fed SET DEFAULT 0.00;
ALTER TABLE caixa_mov_capa ADD COLUMN supcap_vr_imposto_est numeric(10,2);
ALTER TABLE caixa_mov_capa ALTER COLUMN supcap_vr_imposto_est SET DEFAULT 0.00;
ALTER TABLE caixa_mov_capa ADD COLUMN supcap_vr_imposto_mun numeric(10,2);
ALTER TABLE caixa_mov_capa ALTER COLUMN supcap_vr_imposto_mun SET DEFAULT 0.00;

-- caixa_mov_corpos
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_vr_imposto_fed numeric(10,2);
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_vr_imposto_est numeric(10,2);
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_vr_imposto_mun numeric(10,2);
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_ibpt_chave character(10);
          """
        },
        {"websig_sql_id": "88206_6A1",
         "websig_sql_name": "Alera_tamanho_de_colunas",
         "websig_sql_obs": "Alera_tamanho_de_colunas",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_capa,caixa_cad_clientes,caixa_mov_corpos",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """

UPDATE caixa_mov_capa SET supcap_nome_cliente = lpad(supcap_nome_cliente, 40, '');
UPDATE caixa_cad_clientes SET name = lpad(name, 40, ''), supcli_endereco = lpad(supcli_endereco, 40, '');
UPDATE caixa_mov_corpos SET supcor_nome_vendedor = lpad(supcor_nome_vendedor, 40, '');

-- Define o tamanho de 40 para as colunas 'supcap_nome_cliente', 'name' e 'supcli_endereco'
ALTER TABLE caixa_mov_capa ALTER COLUMN supcap_nome_cliente TYPE VARCHAR (40) ;
ALTER TABLE caixa_cad_clientes ALTER COLUMN name TYPE VARCHAR (40) ;
ALTER TABLE caixa_cad_clientes ALTER COLUMN supcli_endereco TYPE VARCHAR (40) ;
ALTER TABLE caixa_mov_corpos ALTER COLUMN supcor_nome_vendedor TYPE VARCHAR (40) ;
          """
        },
        {"websig_sql_id": "93072_6B4",
         "websig_sql_name": "Alterar_ondelete_do_operador_no_cupom",
         "websig_sql_obs": "Alterar_ondelete_do_operador_no_cupom",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_capa",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_capa
    DROP CONSTRAINT caixa_mov_capa_supcap_operador_id_fkey;

ALTER TABLE caixa_mov_capa
  ADD CONSTRAINT caixa_mov_capa_supcap_operador_id_fkey FOREIGN KEY (supcap_operador_id)
      REFERENCES caixa_cad_operadores (id) MATCH SIMPLE
      ON DELETE RESTRICT;
          """
        },
        {"websig_sql_id": "93134_6D2",
         "websig_sql_name": "Inserir_coluna_vr_unitario_dos_itens_kit",
         "websig_sql_obs": "Inserir_coluna_vr_unitario_dos_itens_kit",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_kits",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_kits ADD COLUMN supkit_vr_unitario_no_kit numeric(15,2);
          """
        },
        {"websig_sql_id": "94666_6D1",
         "websig_sql_name": "inserir_coluna_scanntech",
         "websig_sql_obs": "inserir_coluna_scanntech",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "varias tabelas",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_id_promo integer;
ALTER TABLE caixa_cad_itens ADD COLUMN scanntech integer;
ALTER TABLE caixa_mov_capa ADD COLUMN scanntech integer;
ALTER TABLE caixa_mov_corpos ADD COLUMN scanntech integer;
ALTER TABLE caixa_mov_corpo_xz ADD COLUMN scanntech integer;
ALTER TABLE caixa_mov_fechamentos ADD COLUMN scanntech integer;
          """
        },
        {"websig_sql_id": "94995_6E1",
         "websig_sql_name": "inserir_numero_pedido_capa",
         "websig_sql_obs": "inserir_numero_pedido_capa",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_capa",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_capa ADD COLUMN supcap_numero_pedido VARCHAR (20);
          """
        },
        {"websig_sql_id": "95020_6D2",
         "websig_sql_name": "inseir_coluna_supcfp_arq_promocoes",
         "websig_sql_obs": "inseir_coluna_supcfp_arq_promocoes",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cfg_parametros",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cfg_parametros ADD COLUMN supcfp_arq_promocoes VARCHAR (100);
          """
        },
        {"websig_sql_id": "95022_6D2",
         "websig_sql_name": "drop_table_cad_promocao",
         "websig_sql_obs": "drop_table_cad_promocao",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_promocao,caixa_cad_item_promocao",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
DROP TABLE caixa_cad_promocao CASCADE;
DROP TABLE caixa_cad_item_promocao;
          """
        },
        {"websig_sql_id": "95129_6D1",
         "websig_sql_name": "ajustes_em_tabelas",
         "websig_sql_obs": "ajustes_em_tabelas",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_corpos,caixa_mov_totalizadores_xz",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_quantidade_promo numeric(10,3);
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_id_promo integer;
ALTER TABLE caixa_mov_totalizadores_xz ADD COLUMN scanntech integer;

          """
        },
        {"websig_sql_id": "95281_6D1",
         "websig_sql_name": "inserir_coluna_desc_acres",
         "websig_sql_obs": "inserir_coluna_desc_acres",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_corpos",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_desconto_item_sem_rat numeric(10,2);
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_acrescimo_item_sem_rat numeric(10,2);
          """
        },
        {"websig_sql_id": "95861_6D2",
         "websig_sql_name": "inserir_culuna_tipo_promo",
         "websig_sql_obs": "nserir_culuna_tipo_promo",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_corpos",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_tipo_promo VARCHAR (1);
          """
        },
        {"websig_sql_id": "96273_6D2",
         "websig_sql_name": "inserir_coluna_cest",
         "websig_sql_obs": "inserir_coluna_cest",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_itens,caixa_mov_corpos",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_itens ADD COLUMN supite_cest CHAR (7);
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_cest CHAR (7);
          """
        },
        {"websig_sql_id": "96312_6D2",
         "websig_sql_name": "delete_coluna_qtd_autenticacao",
         "websig_sql_obs": "delete_coluna_qtd_autenticacao",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_finalizadora",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_finalizadora DROP COLUMN supfin_qtd_autenticacao;
          """
        },
        {"websig_sql_id": "97047_6D9",
         "websig_sql_name": "criar_index",
         "websig_sql_obs": "criar_index",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_capa,caixa_mov_fechamentos",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
CREATE INDEX ix_caixa_mov_capa_supcap_data_cupom
  ON caixa_mov_capa
  USING btree
  (supcap_data_cupom);
CREATE INDEX ix_caixa_mov_capa_supcap_nro_cupom
  ON caixa_mov_capa
  USING btree
  (supcap_nro_cupom);
CREATE INDEX ix_caixa_mov_capa_supcap_operador_id
  ON caixa_mov_capa
  USING btree
  (supcap_operador_id);
CREATE INDEX ix_caixa_mov_capa_supcap_data_fim
  ON caixa_mov_capa
  USING btree
  (supcap_data_fim);

CREATE INDEX ix_caixa_mov_fechamentos_supfec_capa_id
  ON caixa_mov_fechamentos
  USING btree
  (supfec_capa_id);
          """
        },
        {"websig_sql_id": "97236_6D9",
         "websig_sql_name": "atualiza_sequence_finalizadora",
         "websig_sql_obs": "atualiza_sequence_finalizadora",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_bandeiras,caixa_cad_finalizadora",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """execute:
def alterar_sequence_supervisor_cad_finalizadora():
    max_id = exec_sql('SELECT max(id) AS id FROM caixa_cad_bandeiras', 'C')
    if not max_id:
        return True

    max_id = max_id[0].get('id') + 1
    exec_sql('ALTER SEQUENCE caixa_cad_bandeiras_id_seq RESTART WITH %s;' % max_id)
    print 'Sequence bandeira alterado para: ', max_id
    max_id = exec_sql('SELECT max(id) AS id FROM caixa_cad_finalizadora', 'C')
    if not max_id:
        return True

    max_id = max_id[0].get('id') + 1
    exec_sql('ALTER SEQUENCE caixa_cad_finalizadora_id_seq RESTART WITH %s;' % max_id)
    print 'Sequence finalizadora alterado para: ', max_id
    return True
          """
        },
        {"websig_sql_id": "80013_5G1",
         "websig_sql_name": "alter_mov_corpos",
         "websig_sql_obs": "alter_mov_corpos",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_corpos",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_corpos ALTER COLUMN supcor_nome_item TYPE VARCHAR (60) ;
          """
        },
        {"websig_sql_id": "99199_6E1",
         "websig_sql_name": "Inserir o campo supope_biometria na tabela de operadores",
         "websig_sql_obs": "Inserir o campo supope_biometria na tabela de operadores",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_operadores",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_operadores ADD COLUMN supope_biometria Text;
          """
        },
        {"websig_sql_id": "100694_6J1",
         "websig_sql_name": "Altera o campo supcli_limite_compras para que nao possua limite",
         "websig_sql_obs": "Altera o campo supcli_limite_compras para que nao possua limite",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_clientes",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_clientes ALTER COLUMN supcli_limite_compras TYPE NUMERIC;
          """
        },
        {"websig_sql_id": "102278_6L1",
         "websig_sql_name": "Seta o id do operador nos cupons sem operaror_id",
         "websig_sql_obs": "Seta o id do operador nos cupons sem operaror_id onde o tipo nao eh venda/cancelamento",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_capa",
         "websig_sql_executado": "S",
         "websig_sql_sentenca": """execute:
def set_operador_id_no_cupom():
    cupons_ids = ','.join(map(lambda x: '%s' % x.get(id),
         exec_sql('SELECT id FROM caixa_mov_capa WHERE supcap_operador_id IS NULL', 'C', ret=True)))
    if not cupons_ids:
        return True

    operador_ids = map(lambda x: x.get(id),
                 exec_sql('SELECT id FROM caixa_cad_operadores ORDER BY id LIMIT 1', 'C', ret=True))
    if not operador_ids:
        raise Exception('Nenhum registro encontrado na tabela de operadores!')

    sql = 'UPDATE caixa_mov_capa SET supcap_operador_id = %s WHERE id IN (%s)' % \
          (operador_ids[0], cupons_ids)
    exec_sql(sql, 'C')
    return True
          """
        },
        {"websig_sql_id": "104194_7B01",
         "websig_sql_name": "Cria coluna supcfp_restringe_desconto na tabela caixa_cfg_parametros",
         "websig_sql_obs": "Cria coluna supcfp_restringe_desconto na tabela caixa_cfg_parametros",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cfg_parametros",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cfg_parametros ADD COLUMN supcfp_restringe_desconto BOOLEAN DEFAULT FALSE;
          """
        },
        {"websig_sql_id": "104245_7C01",
         "websig_sql_name": "Cria coluna supcfp_mensagem_doacao na tabela caixa_cfg_parametros",
         "websig_sql_obs": "Cria coluna supcfp_mensagem_doacao na tabela caixa_cfg_parametros",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cfg_parametros",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cfg_parametros ADD COLUMN supcfp_mensagem_doacao TEXT;
          """
        },
        {"websig_sql_id": "105938_7B07",
         "websig_sql_name": "criar_index",
         "websig_sql_obs": "criar_index",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """execute:
def create_index(self):
    tables = {'caixa_mov_corpos': ['id', 'supcor_capa_id', 'supcor_sequencia', 'supcor_item', 
                                   'supcor_desconto_item', 'supcor_acrescimo_item', 
                                   'supcor_tipo_promo', 'supcor_venda_cancelamento'],
              'caixa_cad_promo_capa': ['id', 'supproc_data_hora_inicio', 'supproc_data_hora_fim',
                                       'supproc_id_promo'],
              'caixa_cad_promo1': ['id', 'suppro1_capa_id', 'suppro1_sequencial'],
              'caixa_cad_promo2': ['id', 'suppro2_capa_id', 'suppro2_sequencial'],
              'caixa_cad_promo3p': ['id', 'suppro3p_capa_id', 'suppro3p_sequencial'],
              'caixa_cad_promo3f': ['id', 'suppro3f_capa_id'],
              'caixa_cad_promo4': ['id', 'suppro4_capa_id', 'suppro4_sequencial'],
              'caixa_cad_promo5p': ['id', 'suppro5p_capa_id', 'suppro5p_sequencial'],
              'caixa_cad_promo5f': ['id', 'suppro5f_capa_id'], 
              'caixa_cad_promo6': ['id', 'suppro6_capa_id', 'suppro5p_sequencial'], 
             }
    for table, campos in tables.items():
        for campo in campos:
            try:
                exec_sql('CREATE INDEX ix_{table}_{campo} ON {table} USING btree ({campo});'.format(
                         table=table, 
                         campo=campo), 'C', ret=True)
            except:
                pass
    
    return True
          """
        },
        {"websig_sql_id": "106001_7B07",
         "websig_sql_name": "atualiza_sequence_cupom_servidor",
         "websig_sql_obs": "atualiza_sequence_cupom_servidor",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_cupom_servidor",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """execute:
def alterar_sequence_caixa_mov_cupom_servidor():
    max_id = exec_sql('SELECT max(id) AS id FROM caixa_mov_cupom_servidor', 'C')
    if not max_id or not max_id[0].get('id'):
        return True

    max_id = max_id[0].get('id') + 1
    exec_sql('ALTER SEQUENCE caixa_mov_cupom_servidor_id_seq RESTART WITH %s;' % max_id)
    print 'Sequence cupom servidor alterado para: ', max_id
    return True
          """
        },
        {"websig_sql_id": "106181_7D01",
         "websig_sql_name": "Altera a columna supban_tipo",
         "websig_sql_obs": "Altera a columna supban_tipo",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_bandeiras",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_bandeiras ALTER COLUMN supban_tipo TYPE CHARACTER VARYING(1)
          """
        },
        {"websig_sql_id": "107212_7E01",
         "websig_sql_name": "Adiciona a columna supproc_finalizadora_dinheiro na promcocao",
         "websig_sql_obs": "Adiciona a columna supproc_finalizadora_dinheiro na promcocao",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_promo_capa",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_promo_capa ADD COLUMN supproc_finalizadora_dinheiro BOOLEAN DEFAULT FALSE;
          """
        },
        {"websig_sql_id": "108114_7F02",
         "websig_sql_name": "Altera as colunas supcxz_gt_anterior e supcxz_gt_atual para 18 digitos",
         "websig_sql_obs": "Altera as colunas supcxz_gt_anterior e supcxz_gt_atual para 18 digitos",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_corpo_xz",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_corpo_xz ALTER COLUMN supcxz_gt_anterior TYPE numeric(18,3);
ALTER TABLE caixa_mov_corpo_xz ALTER COLUMN supcxz_gt_atual TYPE numeric(18,3);
          """
        },
        {"websig_sql_id": "109913_7H",
         "websig_sql_name": "Adiciona a coluna supcap_cod_tot_nao_fiscal na capa ",
         "websig_sql_obs": "Controle para fechamento de turno dos cupons nao fiscais",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_capa",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
         
ALTER TABLE caixa_mov_capa ADD COLUMN supcap_cod_tot_nao_fiscal integer;
          """
        },
        {"websig_sql_id": "114117_7K",
         "websig_sql_name": "Adiciona a coluna supaut_liberou_desconto na autorizacao capa ",
         "websig_sql_obs": "Controle para ver qual operador concedeu desconto",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_capa",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
         
ALTER TABLE caixa_mov_autorizacoes ADD COLUMN supaut_liberou_desconto BOOLEAN DEFAULT FALSE;
          """
        },
        {"websig_sql_id": "116171_7L01",
         "websig_sql_name": "Inserir_coluna_supkit_preco_venda",
         "websig_sql_obs": "Inserir_coluna_supkit_preco_venda",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_kits",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_kits ADD COLUMN supkit_preco_venda numeric(15,2);
          """
        },
        {"websig_sql_id": "118040_8B01",
         "websig_sql_name": "Retirar a coluna supkit_vr_unitario_no_kit",
         "websig_sql_obs": "Retirar a coluna supkit_vr_unitario_no_kit",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_cad_kits",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_cad_kits DROP COLUMN supkit_vr_unitario_no_kit;
          """
        },
        {"websig_sql_id": "115548_8C05",
         "websig_sql_name": "Adiciona a coluna supcor_codigo_ficha na mov_corpos ",
         "websig_sql_obs": "Identificacao da ficha caso o mododulo do supervisor esteja instalado",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_corpos",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """execute:
def incluir_campo_cod_ficha_na_corpos():
    if exec_sql("SELECT id FROM ir_module_module WHERE name = 'supervisor_fichas' AND state = 'installed';", 'S'):
        try:
            exec_sql('ALTER TABLE caixa_mov_corpos DROP COLUMN supcor_codigo_ficha;', 'C')
        except:
            pass
            
        exec_sql('ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_codigo_ficha numeric(18,3);', 'C')
        return True
    else:
        return False
          """
        },
        {"websig_sql_id": "88784_8H01",
         "websig_sql_name": "Deletar tabela caixa_nfe_corpos para adicionar o campo do id da capa",
         "websig_sql_obs": "Deletar tabela caixa_nfe_corpos para adicionar o campo do id da capa",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_nfe_corpos",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
DROP TABLE caixa_nfe_corpos;
          """
        },
        {"websig_sql_id": "130707_9A01",
         "websig_sql_name": "Criar campo de relacionamento com a tabela de kits vendidos",
         "websig_sql_obs": "Criar campo de relacionamento com a tabela de kits vendidos",
         "websig_sql_momento": "A",
         "websig_sql_tabela": "caixa_mov_corpos",
         "websig_sql_executado": "N",
         "websig_sql_sentenca": """
ALTER TABLE caixa_mov_corpos ADD COLUMN supcor_kit_vendido_id integer;
ALTER TABLE caixa_mov_corpos
  ADD CONSTRAINT caixa_mov_corpos_supcor_kit_vendido_id_fkey FOREIGN KEY (supcor_kit_vendido_id)
      REFERENCES caixa_mov_kits_vendidos (id) MATCH SIMPLE
      ON DELETE CASCADE;
          """
        },

    ]
}